abstract type FIRKMutableCache <: OrdinaryDiffEqMutableCache end
get_fsalfirstlast(cache::FIRKMutableCache, u) = (cache.fsalfirst, cache.k)

mutable struct RadauIIA3ConstantCache{F, Tab, Tol, Dt, U, JType} <:
    OrdinaryDiffEqConstantCache
    uf::F
    tab::Tab
    κ::Tol
    ηold::Tol
    iter::Int
    cont1::U
    cont2::U
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    J::JType
end

function alg_cache(
        alg::RadauIIA3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UDerivativeWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)
    tab = RadauIIA3Tableau(uToltype, constvalue(tTypeNoUnits))

    κ = convert(uToltype, 1 // 100)
    J = false .* _vec(rate_prototype) .* _vec(rate_prototype)'

    return RadauIIA3ConstantCache(
        uf, tab, κ, one(uToltype), 10000, u, u, dt, dt,
        Convergence, J
    )
end

mutable struct RadauIIA3Cache{
        uType, cuType, uNoUnitsType, rateType, JType, W1Type, UF, JC,
        F1, Tab, Tol, Dt, rTol, aTol, StepLimiter,
    } <: FIRKMutableCache
    u::uType
    uprev::uType
    z1::uType
    z2::uType
    w1::uType
    w2::uType
    dw12::cuType
    cubuff::cuType
    du1::rateType
    fsalfirst::rateType
    k::rateType
    k2::rateType
    fw1::rateType
    fw2::rateType
    J::JType
    W1::W1Type
    uf::UF
    tab::Tab
    κ::Tol
    ηold::Tol
    iter::Int
    tmp::uType
    atmp::uNoUnitsType
    jac_config::JC
    linsolve::F1
    rtol::rTol
    atol::aTol
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    step_limiter!::StepLimiter
end

function alg_cache(
        alg::RadauIIA3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UJacobianWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)
    tab = RadauIIA3Tableau(uToltype, constvalue(tTypeNoUnits))

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)

    z1 = zero(u)
    z2 = zero(u)
    w1 = zero(u)
    w2 = zero(u)
    dw12 = similar(u, Complex{eltype(u)})
    recursivefill!(dw12, false)
    cubuff = similar(u, Complex{eltype(u)})
    recursivefill!(cubuff, false)

    fsalfirst = zero(rate_prototype)
    k = zero(rate_prototype)
    k2 = zero(rate_prototype)
    fw1 = zero(rate_prototype)
    fw2 = zero(rate_prototype)

    du1 = zero(rate_prototype)

    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dw12)

    J, W1 = build_J_W(alg, u, uprev, p, t, dt, f, jac_config, uEltypeNoUnits, Val(true))
    W1 = similar(J, Complex{eltype(W1)})
    recursivefill!(W1, false)

    linprob = LinearProblem(W1, _vec(cubuff); u0 = _vec(dw12))
    linsolve = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        abstol = reltol, reltol = reltol,
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )
    #Pl = LinearSolve.InvPreconditioner(Diagonal(_vec(weight))),
    #Pr = Diagonal(_vec(weight)))

    rtol = reltol isa Number ? reltol : zero(reltol)
    atol = reltol isa Number ? reltol : zero(reltol)

    return RadauIIA3Cache(
        u, uprev,
        z1, z2, w1, w2,
        dw12, cubuff,
        du1, fsalfirst, k, k2, fw1, fw2,
        J, W1,
        uf, tab, κ, one(uToltype), 10000,
        tmp, atmp, jac_config, linsolve, rtol, atol, dt, dt,
        Convergence, alg.step_limiter!
    )
end

mutable struct RadauIIA5ConstantCache{F, Tab, Tol, Dt, U, JType} <:
    OrdinaryDiffEqConstantCache
    uf::F
    tab::Tab
    κ::Tol
    ηold::Tol
    iter::Int
    cont1::U
    cont2::U
    cont3::U
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    J::JType
end

function alg_cache(
        alg::RadauIIA5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UDerivativeWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)
    tab = RadauIIA5Tableau(uToltype, constvalue(tTypeNoUnits))

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)
    J = false .* _vec(rate_prototype) .* _vec(rate_prototype)'

    return RadauIIA5ConstantCache(
        uf, tab, κ, one(uToltype), 10000, u, u, u, dt, dt,
        Convergence, J
    )
end

mutable struct RadauIIA5Cache{
        uType, cuType, uNoUnitsType, rateType, JType, W1Type, W2Type,
        UF, JC, F1, F2, Tab, Tol, Dt, rTol, aTol, StepLimiter,
    } <:
    FIRKMutableCache
    u::uType
    uprev::uType
    z1::uType
    z2::uType
    z3::uType
    w1::uType
    w2::uType
    w3::uType
    dw1::uType
    ubuff::uType
    dw23::cuType
    cubuff::cuType
    du1::rateType
    fsalfirst::rateType
    k::rateType
    k1::rateType
    k2::rateType
    k3::rateType
    fw1::rateType
    fw2::rateType
    fw3::rateType
    J::JType
    W1::W1Type
    W2::W2Type # complex
    uf::UF
    tab::Tab
    κ::Tol
    ηold::Tol
    iter::Int
    tmp::uType
    atmp::uNoUnitsType
    jac_config::JC
    linsolve1::F1
    linsolve2::F2
    rtol::rTol
    atol::aTol
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    step_limiter!::StepLimiter
end

function alg_cache(
        alg::RadauIIA5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UJacobianWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)
    tab = RadauIIA5Tableau(uToltype, constvalue(tTypeNoUnits))

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)

    z1 = zero(u)
    z2 = zero(u)
    z3 = zero(u)
    w1 = zero(u)
    w2 = zero(u)
    w3 = zero(u)
    dw1 = zero(u)
    ubuff = zero(u)
    dw23 = similar(u, Complex{eltype(u)})
    recursivefill!(dw23, false)
    cubuff = similar(u, Complex{eltype(u)})
    recursivefill!(cubuff, false)

    fsalfirst = zero(rate_prototype)
    k = zero(rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    fw1 = zero(rate_prototype)
    fw2 = zero(rate_prototype)
    fw3 = zero(rate_prototype)

    du1 = zero(rate_prototype)

    tmp = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dw1)

    J, W1 = build_J_W(alg, u, uprev, p, t, dt, f, jac_config, uEltypeNoUnits, Val(true))
    if J isa AbstractSciMLOperator
        error("Non-concrete Jacobian not yet supported by RadauIIA5.")
    end
    W2 = similar(J, Complex{eltype(W1)})
    recursivefill!(W2, false)

    linprob = LinearProblem(W1, _vec(ubuff); u0 = _vec(dw1))
    linsolve1 = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )
    #Pl = LinearSolve.InvPreconditioner(Diagonal(_vec(weight))),
    #Pr = Diagonal(_vec(weight)))
    linprob = LinearProblem(W2, _vec(cubuff); u0 = _vec(dw23))
    linsolve2 = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )
    #Pl = LinearSolve.InvPreconditioner(Diagonal(_vec(weight))),
    #Pr = Diagonal(_vec(weight)))

    rtol = reltol isa Number ? reltol : zero(reltol)
    atol = reltol isa Number ? reltol : zero(reltol)

    return RadauIIA5Cache(
        u, uprev,
        z1, z2, z3, w1, w2, w3,
        dw1, ubuff, dw23, cubuff,
        du1, fsalfirst, k, k1, k2, k3, fw1, fw2, fw3,
        J, W1, W2,
        uf, tab, κ, one(uToltype), 10000,
        tmp, atmp, jac_config, linsolve1, linsolve2, rtol, atol, dt, dt,
        Convergence, alg.step_limiter!
    )
end

mutable struct RadauIIA9ConstantCache{F, Tab, Tol, Dt, U, JType} <:
    OrdinaryDiffEqConstantCache
    uf::F
    tab::Tab
    κ::Tol
    ηold::Tol
    iter::Int
    cont1::U
    cont2::U
    cont3::U
    cont4::U
    cont5::U
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    J::JType
end

function alg_cache(
        alg::RadauIIA9, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UDerivativeWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)
    tab = RadauIIA9Tableau(uToltype, constvalue(tTypeNoUnits))

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)
    J = false .* _vec(rate_prototype) .* _vec(rate_prototype)'

    return RadauIIA9ConstantCache(
        uf, tab, κ, one(uToltype), 10000, u, u, u, u, u, dt, dt,
        Convergence, J
    )
end

mutable struct RadauIIA9Cache{
        uType, cuType, uNoUnitsType, rateType, JType, W1Type, W2Type,
        UF, JC, F1, F2, Tab, Tol, Dt, rTol, aTol, StepLimiter,
    } <:
    FIRKMutableCache
    u::uType
    uprev::uType
    z1::uType
    z2::uType
    z3::uType
    z4::uType
    z5::uType
    w1::uType
    w2::uType
    w3::uType
    w4::uType
    w5::uType
    dw1::uType
    ubuff::uType
    dw23::cuType
    dw45::cuType
    cubuff1::cuType
    cubuff2::cuType
    du1::rateType
    fsalfirst::rateType
    k::rateType
    k1::rateType
    k2::rateType
    k3::rateType
    k4::rateType
    k5::rateType
    fw1::rateType
    fw2::rateType
    fw3::rateType
    fw4::rateType
    fw5::rateType
    J::JType
    W1::W1Type
    W2::W2Type # complex
    W3::W2Type
    uf::UF
    tab::Tab
    κ::Tol
    ηold::Tol
    iter::Int
    tmp::uType
    tmp2::uType
    tmp3::uType
    tmp4::uType
    tmp5::uType
    tmp6::uType
    tmp7::uType
    tmp8::uType
    tmp9::uType
    tmp10::uType
    atmp::uNoUnitsType
    jac_config::JC
    linsolve1::F1
    linsolve2::F2
    linsolve3::F2
    rtol::rTol
    atol::aTol
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    step_limiter!::StepLimiter
end

function alg_cache(
        alg::RadauIIA9, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UJacobianWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)
    tab = RadauIIA9Tableau(uToltype, constvalue(tTypeNoUnits))

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)

    z1 = zero(u)
    z2 = zero(u)
    z3 = zero(u)
    z4 = zero(u)
    z5 = zero(u)
    w1 = zero(u)
    w2 = zero(u)
    w3 = zero(u)
    w4 = zero(u)
    w5 = zero(u)
    dw1 = zero(u)
    ubuff = zero(u)
    dw23 = similar(u, Complex{eltype(u)})
    dw45 = similar(u, Complex{eltype(u)})
    recursivefill!(dw23, false)
    recursivefill!(dw45, false)
    cubuff1 = similar(u, Complex{eltype(u)})
    cubuff2 = similar(u, Complex{eltype(u)})
    recursivefill!(cubuff1, false)
    recursivefill!(cubuff2, false)

    fsalfirst = zero(rate_prototype)
    k = zero(rate_prototype)
    k1 = zero(rate_prototype)
    k2 = zero(rate_prototype)
    k3 = zero(rate_prototype)
    k4 = zero(rate_prototype)
    k5 = zero(rate_prototype)
    fw1 = zero(rate_prototype)
    fw2 = zero(rate_prototype)
    fw3 = zero(rate_prototype)
    fw4 = zero(rate_prototype)
    fw5 = zero(rate_prototype)

    du1 = zero(rate_prototype)

    tmp = zero(u)
    tmp2 = zero(u)
    tmp3 = zero(u)
    tmp4 = zero(u)
    tmp5 = zero(u)
    tmp6 = zero(u)
    tmp7 = zero(u)
    tmp8 = zero(u)
    tmp9 = zero(u)
    tmp10 = zero(u)
    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)
    jac_config = build_jac_config(alg, f, uf, du1, uprev, u, tmp, dw1)

    J, W1 = build_J_W(alg, u, uprev, p, t, dt, f, jac_config, uEltypeNoUnits, Val(true))
    if J isa AbstractSciMLOperator
        error("Non-concrete Jacobian not yet supported by RadauIIA5.")
    end
    W2 = similar(J, Complex{eltype(W1)})
    W3 = similar(J, Complex{eltype(W1)})
    recursivefill!(W2, false)
    recursivefill!(W3, false)

    linprob = LinearProblem(W1, _vec(ubuff); u0 = _vec(dw1))
    linsolve1 = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )
    #Pl = LinearSolve.InvPreconditioner(Diagonal(_vec(weight))),
    #Pr = Diagonal(_vec(weight)))
    linprob = LinearProblem(W2, _vec(cubuff1); u0 = _vec(dw23))
    linsolve2 = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )
    #Pl = LinearSolve.InvPreconditioner(Diagonal(_vec(weight))),
    #Pr = Diagonal(_vec(weight)))
    linprob = LinearProblem(W3, _vec(cubuff2); u0 = _vec(dw45))
    linsolve3 = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )
    #Pl = LinearSolve.InvPreconditioner(Diagonal(_vec(weight))),
    #Pr = Diagonal(_vec(weight)))

    rtol = reltol isa Number ? reltol : zero(reltol)
    atol = reltol isa Number ? reltol : zero(reltol)

    return RadauIIA9Cache(
        u, uprev,
        z1, z2, z3, z4, z5, w1, w2, w3, w4, w5,
        dw1, ubuff, dw23, dw45, cubuff1, cubuff2,
        du1, fsalfirst, k, k1, k2, k3, k4, k5, fw1, fw2, fw3, fw4, fw5,
        J, W1, W2, W3,
        uf, tab, κ, one(uToltype), 10000,
        tmp, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp9, tmp10, atmp, jac_config,
        linsolve1, linsolve2, linsolve3, rtol, atol, dt, dt,
        Convergence, alg.step_limiter!
    )
end

mutable struct AdaptiveRadauConstantCache{F, Tab, Tol, Dt, U, JType} <:
    OrdinaryDiffEqConstantCache
    uf::F
    tabs::Vector{Tab}
    κ::Tol
    ηold::Tol
    iter::Int
    cont::Vector{U}
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    J::JType
    num_stages::Int
    step::Int
    hist_iter::Float64
    index::Int
end

function alg_cache(
        alg::AdaptiveRadau, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UDerivativeWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)

    max_order = alg.max_order
    min_order = alg.min_order
    max_stages = (max_order - 1) ÷ 4 * 2 + 1
    min_stages = (min_order - 1) ÷ 4 * 2 + 1
    if (alg.min_order < 5)
        error("min_order choice $min_order below 5 is not compatible with the algorithm")
    elseif (max_stages < min_stages)
        error("max_order $max_order is below min_order $min_order")
    end
    num_stages = min_stages

    tabs = [
        RadauIIATableau(uToltype, constvalue(tTypeNoUnits), i)
            for i in min_stages:2:max_stages
    ]
    cont = Vector{typeof(u)}(undef, max_stages)
    for i in 1:max_stages
        cont[i] = zero(u)
    end

    index = 1

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)
    J = false .* _vec(rate_prototype) .* _vec(rate_prototype)'
    return AdaptiveRadauConstantCache(
        uf, tabs, κ, one(uToltype), 10000, cont, dt, dt,
        Convergence, J, num_stages, 1, 0.0, index
    )
end

mutable struct AdaptiveRadauCache{
        uType, cuType, tType, uNoUnitsType, rateType, JType, W1Type, W2Type,
        UF, JC, F1, F2, Tab, Tol, Dt, rTol, aTol, StepLimiter,
    } <:
    FIRKMutableCache
    u::uType
    uprev::uType
    z::Vector{uType}
    w::Vector{uType}
    c_prime::Vector{tType}
    αdt::Vector{tType}
    βdt::Vector{tType}
    dw1::uType
    ubuff::uType
    dw2::Vector{cuType}
    cubuff::Vector{cuType}
    dw::Vector{uType}
    derivatives::Matrix{uType}
    du1::rateType
    fsalfirst::rateType
    ks::Vector{rateType}
    k::rateType
    fw::Vector{rateType}
    J::JType
    W1::W1Type #real
    W2::Vector{W2Type} #complex
    uf::UF
    tabs::Vector{Tab}
    κ::Tol
    ηold::Tol
    iter::Int
    tmp::uType
    atmp::uNoUnitsType
    jac_config::JC
    linsolve1::F1 #real
    linsolve2::Vector{F2} #complex
    rtol::rTol
    atol::aTol
    dtprev::Dt
    W_γdt::Dt
    status::NLStatus
    step_limiter!::StepLimiter
    num_stages::Int
    step::Int
    hist_iter::Float64
    index::Int
end

function alg_cache(
        alg::AdaptiveRadau, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits},
        ::Type{tTypeNoUnits}, uprev, uprev2, f, t, dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    uf = UJacobianWrapper(f, t, p)
    uToltype = constvalue(uBottomEltypeNoUnits)

    max_order = alg.max_order
    min_order = alg.min_order
    max_stages = (max_order - 1) ÷ 4 * 2 + 1
    min_stages = (min_order - 1) ÷ 4 * 2 + 1
    if (alg.min_order < 5)
        error("min_order choice $min_order below 5 is not compatible with the algorithm")
    elseif (max_stages < min_stages)
        error("max_order $max_order is below min_order $min_order")
    end
    num_stages = min_stages

    tabs = [
        RadauIIATableau(uToltype, constvalue(tTypeNoUnits), i)
            for i in min_stages:2:max_stages
    ]

    index = 1

    κ = alg.κ !== nothing ? convert(uToltype, alg.κ) : convert(uToltype, 1 // 100)

    z = Vector{typeof(u)}(undef, max_stages)
    w = Vector{typeof(u)}(undef, max_stages)
    for i in 1:max_stages
        z[i] = zero(u)
        w[i] = zero(u)
    end

    αdt = [zero(t) for i in 1:max_stages]
    βdt = [zero(t) for i in 1:max_stages]
    c_prime = Vector{typeof(t)}(undef, max_stages) #time stepping
    for i in 1:max_stages
        c_prime[i] = zero(t)
    end

    dw1 = zero(u)
    ubuff = zero(u)
    dw2 = [similar(u, Complex{eltype(u)}) for _ in 1:((max_stages - 1) ÷ 2)]
    recursivefill!.(dw2, false)
    cubuff = [similar(u, Complex{eltype(u)}) for _ in 1:((max_stages - 1) ÷ 2)]
    recursivefill!.(cubuff, false)
    dw = [zero(u) for i in 1:max_stages]

    derivatives = Matrix{typeof(u)}(undef, max_stages, max_stages)
    for i in 1:max_stages, j in 1:max_stages

        derivatives[i, j] = zero(u)
    end
    fsalfirst = zero(rate_prototype)
    fw = [zero(rate_prototype) for i in 1:max_stages]
    ks = [zero(rate_prototype) for i in 1:max_stages]

    k = ks[1]

    du1 = zero(rate_prototype)

    tmp = zero(u)

    atmp = similar(u, uEltypeNoUnits)
    recursivefill!(atmp, false)

    jac_config = build_jac_config(alg, f, uf, du1, uprev, u, zero(u), dw1)

    J, W1 = build_J_W(alg, u, uprev, p, t, dt, f, jac_config, uEltypeNoUnits, Val(true))
    if J isa AbstractSciMLOperator
        error("Non-concrete Jacobian not yet supported by AdaptiveRadau.")
    end

    W2 = [similar(J, Complex{eltype(W1)}) for _ in 1:((max_stages - 1) ÷ 2)]
    recursivefill!.(W2, false)

    linprob = LinearProblem(W1, _vec(ubuff); u0 = _vec(dw1))
    linsolve1 = init(
        linprob, alg.linsolve, alias = LinearAliasSpecifier(alias_A = true, alias_b = true),
        assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
    )

    linsolve2 = [
        init(
                LinearProblem(W2[i], _vec(cubuff[i]); u0 = _vec(dw2[i])),
                alg.linsolve, alias = LinearAliasSpecifier(
                    alias_A = true, alias_b = true
                ),
                assumptions = LinearSolve.OperatorAssumptions(true), verbose = verbose.linear_verbosity
            )
            for i in 1:((max_stages - 1) ÷ 2)
    ]

    rtol = reltol isa Number ? reltol : zero(reltol)
    atol = reltol isa Number ? reltol : zero(reltol)

    return AdaptiveRadauCache(
        u, uprev,
        z, w, c_prime, αdt, βdt, dw1, ubuff, dw2, cubuff, dw, derivatives,
        du1, fsalfirst, ks, k, fw,
        J, W1, W2,
        uf, tabs, κ, one(uToltype), 10000, tmp,
        atmp, jac_config,
        linsolve1, linsolve2, rtol, atol, dt, dt,
        Convergence, alg.step_limiter!, num_stages, 1, 0.0, index
    )
end

function step_accept_controller!(
        integrator, controller::PredictiveController, alg::AdaptiveRadau, q
    )
    (; qmin, qmax, gamma, qsteady_min, qsteady_max) = integrator.opts
    qmax = get_current_qmax(integrator, qmax)
    (; cache) = integrator
    (; num_stages, step, iter, hist_iter, index) = cache

    EEst = DiffEqBase.value(integrator.EEst)

    if integrator.success_iter > 0
        expo = 1 / (get_current_adaptive_order(alg, integrator.cache) + 1)
        qgus = (integrator.dtacc / integrator.dt) *
            fastpower((EEst^2) / integrator.erracc, expo)
        qgus = max(inv(qmax), min(inv(qmin), qgus / gamma))
        qacc = max(q, qgus)
    else
        qacc = q
    end
    if qsteady_min <= qacc <= qsteady_max
        qacc = one(qacc)
    end
    integrator.dtacc = integrator.dt
    integrator.erracc = max(1.0e-2, EEst)
    cache.step = step + 1
    hist_iter = hist_iter * 0.8 + iter * 0.2
    cache.hist_iter = hist_iter
    max_stages = (alg.max_order - 1) ÷ 4 * 2 + 1
    min_stages = (alg.min_order - 1) ÷ 4 * 2 + 1
    if (step > 10)
        if (hist_iter < 2.6 && num_stages < max_stages)
            cache.num_stages += 2
            cache.index += 1
            cache.step = 1
            cache.hist_iter = iter
        elseif (
                (
                    hist_iter > 8 || cache.status == VerySlowConvergence ||
                        cache.status == Divergence
                ) && num_stages > min_stages
            )
            cache.num_stages -= 2
            cache.index -= 1
            cache.step = 1
            cache.hist_iter = iter
        end
    end
    return integrator.dt / qacc
end

function step_reject_controller!(
        integrator, controller::PredictiveController, alg::AdaptiveRadau
    )
    (; dt, success_iter, qold) = integrator
    (; cache) = integrator
    (; num_stages, step, iter, hist_iter) = cache
    integrator.dt = success_iter == 0 ? 0.1 * dt : dt / qold
    cache.step = step + 1
    hist_iter = hist_iter * 0.8 + iter * 0.2
    cache.hist_iter = hist_iter
    min_stages = (alg.min_order - 1) ÷ 4 * 2 + 1
    return if (step > 10)
        if (
                (
                    hist_iter > 8 || cache.status == VerySlowConvergence ||
                        cache.status == Divergence
                ) && num_stages > min_stages
            )
            cache.num_stages -= 2
            cache.index -= 1
            cache.step = 1
            cache.hist_iter = iter
        end
    end
end
@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        function step_accept_controller!(
                integrator, ccache::PredictiveControllerCache, alg::AdaptiveRadau, q
            )
            (; controller) = ccache
            (; qmin, qmax, gamma, qsteady_min, qsteady_max) = controller
            qmax = get_current_qmax(integrator, qmax)
            (; cache) = integrator
            (; num_stages, step, iter, hist_iter, index) = cache

            EEst = DiffEqBase.value(integrator.EEst)

            if integrator.success_iter > 0
                expo = 1 / (get_current_adaptive_order(alg, cache) + 1)
                qgus = (ccache.dtacc / integrator.dt) *
                    fastpower((EEst^2) / ccache.erracc, expo)
                qgus = max(inv(qmax), min(inv(qmin), qgus / gamma))
                qacc = max(q, qgus)
            else
                qacc = q
            end
            if qsteady_min <= qacc <= qsteady_max
                qacc = one(qacc)
            end
            ccache.dtacc = integrator.dt
            ccache.erracc = max(1.0e-2, EEst)
            cache.step = step + 1
            hist_iter = hist_iter * 0.8 + iter * 0.2
            cache.hist_iter = hist_iter
            max_stages = (alg.max_order - 1) ÷ 4 * 2 + 1
            min_stages = (alg.min_order - 1) ÷ 4 * 2 + 1
            if (step > 10)
                if (hist_iter < 2.6 && num_stages < max_stages)
                    cache.num_stages += 2
                    cache.index += 1
                    cache.step = 1
                    cache.hist_iter = iter
                elseif (
                        (
                            hist_iter > 8 || cache.status == VerySlowConvergence ||
                                cache.status == Divergence
                        ) && num_stages > min_stages
                    )
                    cache.num_stages -= 2
                    cache.index -= 1
                    cache.step = 1
                    cache.hist_iter = iter
                end
            end
            return integrator.dt / qacc
        end

        function step_reject_controller!(
                integrator, ccache::PredictiveControllerCache, alg::AdaptiveRadau
            )
            (; controller) = ccache
            (; cache) = controller
            (; dt, success_iter) = integrator
            (; num_stages, step, iter, hist_iter) = cache
            integrator.dt = success_iter == 0 ? 0.1 * dt : dt / ccache.qold
            cache.step = step + 1
            hist_iter = hist_iter * 0.8 + iter * 0.2
            cache.hist_iter = hist_iter
            min_stages = (alg.min_order - 1) ÷ 4 * 2 + 1
            return if (step > 10)
                if (
                        (
                            hist_iter > 8 || cache.status == VerySlowConvergence ||
                                cache.status == Divergence
                        ) && num_stages > min_stages
                    )
                    cache.num_stages -= 2
                    cache.index -= 1
                    cache.step = 1
                    cache.hist_iter = iter
                end
            end
        end
    end
end

hairer1999stiff = """@article{hairer1999stiff,
title={Stiff differential equations solved by Radau methods},
author={Hairer, Ernst and Wanner, Gerhard},
journal={Journal of Computational and Applied Mathematics},
volume={111},
number={1-2},
pages={93--111},
year={1999},
publisher={Elsevier}}"""

extra_keyword_description = """
- `extrapolant`: TBD
- `smooth_est`: TBD
- `step_limiter!`: function of the form `limiter!(u, integrator, p, t)`"""
extra_keyword_default = """
extrapolant = :dense,
smooth_est = true,
step_limiter! = trivial_limiter!"""

@doc differentiation_rk_docstring(
    "An A-B-L stable fully implicit Runge-Kutta method with internal tableau complex basis transform for efficiency.
Similar to Hairer's SEULEX.",
    "RadauIIA3",
    "Fully-Implicit Runge-Kutta Method.";
    references = hairer1999stiff,
    extra_keyword_description = extra_keyword_description,
    extra_keyword_default = extra_keyword_default
)
struct RadauIIA3{CS, AD, F, P, FDT, ST, CJ, Tol, C1, C2, StepLimiter} <:
    OrdinaryDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    extrapolant::Symbol
    κ::Tol
    maxiters::Int
    fast_convergence_cutoff::C1
    new_W_γdt_cutoff::C2
    controller::Symbol
    step_limiter!::StepLimiter
    autodiff::AD
end

function RadauIIA3(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(), concrete_jac = nothing,
        diff_type = Val{:forward}(),
        linsolve = nothing, precs = DEFAULT_PRECS,
        extrapolant = :dense, fast_convergence_cutoff = 1 // 5,
        new_W_γdt_cutoff = 1 // 5,
        controller = :Predictive, κ = nothing, maxiters = 10,
        step_limiter! = trivial_limiter!
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    return RadauIIA3{
        _unwrap_val(chunk_size), typeof(AD_choice), typeof(linsolve),
        typeof(precs), diff_type, _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(κ), typeof(fast_convergence_cutoff),
        typeof(new_W_γdt_cutoff), typeof(step_limiter!),
    }(
        linsolve,
        precs,
        extrapolant,
        κ,
        maxiters,
        fast_convergence_cutoff,
        new_W_γdt_cutoff,
        controller,
        step_limiter!,
        AD_choice
    )
end

@doc differentiation_rk_docstring(
    "An A-B-L stable fully implicit Runge-Kutta method with internal tableau complex basis transform for efficiency. 5th order method with excellent numerical stability. Good for highly stiff systems, problems requiring high-order implicit integration, systems with complex eigenvalue structures. Best for low tolerance stiff problems (<1e-9).",
    "RadauIIA5",
    "Fully-Implicit Runge-Kutta Method.";
    references = hairer1999stiff,
    extra_keyword_description = extra_keyword_description,
    extra_keyword_default = extra_keyword_default
)
struct RadauIIA5{CS, AD, F, P, FDT, ST, CJ, Tol, C1, C2, StepLimiter} <:
    OrdinaryDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    smooth_est::Bool
    extrapolant::Symbol
    κ::Tol
    maxiters::Int
    fast_convergence_cutoff::C1
    new_W_γdt_cutoff::C2
    controller::Symbol
    step_limiter!::StepLimiter
    autodiff::AD
end

function RadauIIA5(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(), concrete_jac = nothing,
        diff_type = Val{:forward}(),
        linsolve = nothing, precs = DEFAULT_PRECS,
        extrapolant = :dense, fast_convergence_cutoff = 1 // 5,
        new_W_γdt_cutoff = 1 // 5,
        controller = :Predictive, κ = nothing, maxiters = 10, smooth_est = true,
        step_limiter! = trivial_limiter!
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    return RadauIIA5{
        _unwrap_val(chunk_size), typeof(AD_choice), typeof(linsolve),
        typeof(precs), diff_type, _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(κ), typeof(fast_convergence_cutoff),
        typeof(new_W_γdt_cutoff), typeof(step_limiter!),
    }(
        linsolve,
        precs,
        smooth_est,
        extrapolant,
        κ,
        maxiters,
        fast_convergence_cutoff,
        new_W_γdt_cutoff,
        controller,
        step_limiter!,
        AD_choice
    )
end

@doc differentiation_rk_docstring(
    "An A-B-L stable fully implicit Runge-Kutta method with internal tableau complex basis transform for efficiency.
Similar to Hairer's SEULEX.",
    "RadauIIA9",
    "Fully-Implicit Runge-Kutta Method.";
    references = hairer1999stiff,
    extra_keyword_description = extra_keyword_description,
    extra_keyword_default = extra_keyword_default
)
struct RadauIIA9{CS, AD, F, P, FDT, ST, CJ, Tol, C1, C2, StepLimiter} <:
    OrdinaryDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    smooth_est::Bool
    extrapolant::Symbol
    κ::Tol
    maxiters::Int
    fast_convergence_cutoff::C1
    new_W_γdt_cutoff::C2
    controller::Symbol
    step_limiter!::StepLimiter
    autodiff::AD
end

function RadauIIA9(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(), concrete_jac = nothing,
        diff_type = Val{:forward}(),
        linsolve = nothing, precs = DEFAULT_PRECS,
        extrapolant = :dense, fast_convergence_cutoff = 1 // 5,
        new_W_γdt_cutoff = 1 // 5,
        controller = :Predictive, κ = nothing, maxiters = 10, smooth_est = true,
        step_limiter! = trivial_limiter!
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    return RadauIIA9{
        _unwrap_val(chunk_size), typeof(AD_choice), typeof(linsolve),
        typeof(precs), diff_type, _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(κ), typeof(fast_convergence_cutoff),
        typeof(new_W_γdt_cutoff), typeof(step_limiter!),
    }(
        linsolve,
        precs,
        smooth_est,
        extrapolant,
        κ,
        maxiters,
        fast_convergence_cutoff,
        new_W_γdt_cutoff,
        controller,
        step_limiter!,
        AD_choice
    )
end

struct AdaptiveRadau{CS, AD, F, P, FDT, ST, CJ, Tol, C1, C2, StepLimiter, TO} <:
    OrdinaryDiffEqNewtonAdaptiveAlgorithm{CS, AD, FDT, ST, CJ}
    linsolve::F
    precs::P
    smooth_est::Bool
    extrapolant::Symbol
    κ::Tol
    maxiters::Int
    fast_convergence_cutoff::C1
    new_W_γdt_cutoff::C2
    controller::Symbol
    step_limiter!::StepLimiter
    min_order::Int
    max_order::Int
    threading::TO
    autodiff::AD
end

function AdaptiveRadau(;
        chunk_size = Val{0}(), autodiff = AutoForwardDiff(),
        standardtag = Val{true}(), concrete_jac = nothing,
        diff_type = Val{:forward}(), min_order = 5, max_order = 13, threading = false,
        linsolve = nothing, precs = DEFAULT_PRECS,
        extrapolant = :dense, fast_convergence_cutoff = 1 // 5,
        new_W_γdt_cutoff = 1 // 5,
        controller = :Predictive, κ = nothing, maxiters = 10, smooth_est = true,
        step_limiter! = trivial_limiter!
    )
    AD_choice, chunk_size, diff_type = _process_AD_choice(autodiff, chunk_size, diff_type)

    return AdaptiveRadau{
        _unwrap_val(chunk_size), typeof(AD_choice), typeof(linsolve),
        typeof(precs), diff_type, _unwrap_val(standardtag), _unwrap_val(concrete_jac),
        typeof(κ), typeof(fast_convergence_cutoff),
        typeof(new_W_γdt_cutoff), typeof(step_limiter!), typeof(threading),
    }(
        linsolve,
        precs,
        smooth_est,
        extrapolant,
        κ,
        maxiters,
        fast_convergence_cutoff,
        new_W_γdt_cutoff,
        controller,
        step_limiter!, min_order, max_order, threading,
        AD_choice
    )
end

qmax_default(alg::Union{RadauIIA3, RadauIIA5, RadauIIA9, AdaptiveRadau}) = 8

alg_order(alg::RadauIIA3) = 3
alg_order(alg::RadauIIA5) = 5
alg_order(alg::RadauIIA9) = 9
alg_order(alg::AdaptiveRadau) = 5 #dummy value

isfirk(alg::RadauIIA3) = true
isfirk(alg::RadauIIA5) = true
isfirk(alg::RadauIIA9) = true
isfirk(alg::AdaptiveRadau) = true

alg_adaptive_order(alg::RadauIIA3) = 1
alg_adaptive_order(alg::RadauIIA5) = 3
alg_adaptive_order(alg::RadauIIA9) = 5

get_current_alg_order(alg::AdaptiveRadau, cache) = cache.num_stages * 2 - 1
get_current_adaptive_order(alg::AdaptiveRadau, cache) = cache.num_stages

function has_stiff_interpolation(::Union{RadauIIA3, RadauIIA5, RadauIIA9, AdaptiveRadau})
    return true
end

FIRK_WITH_INTERPOLATIONS = Union{
    RadauIIA3ConstantCache, RadauIIA3Cache, RadauIIA5ConstantCache, RadauIIA5Cache,
    RadauIIA9ConstantCache, RadauIIA9Cache, AdaptiveRadauConstantCache, AdaptiveRadauCache,
}

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k, cache::Union{RadauIIA3ConstantCache, RadauIIA3Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; c1) = cache.tab
    z1 = k[3]
    z2 = k[4]
    #(0,0), (c1, z1), (1,z2)
    l1 = (Θ - 0) * (Θ - 1) / ((c1 - 0) * (c1 - 1))
    l2 = (Θ - 0) * (Θ - c1) / ((1 - 0) * (1 - c1))
    @.. y₀ + z1 * l1 + z2 * l2
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k, cache::Union{RadauIIA3ConstantCache, RadauIIA3Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; c1) = cache.tab
    z1 = k[3]
    z2 = k[4]
    #(0,0), (c1, z1), (1,z2)
    l1 = (Θ - 0) * (Θ - 1) / ((c1 - 0) * (c1 - 1))
    l2 = (Θ - 0) * (Θ - c1) / ((1 - 0) * (1 - c1))
    @.. out = y₀ + z1 * l1 + z2 * l2
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k, cache::Union{RadauIIA5ConstantCache, RadauIIA5Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; c1, c2) = cache.tab
    z1 = k[3]
    z2 = k[4]
    z3 = k[5]

    l1 = (Θ - 0) * (Θ - c2) * (Θ - 1) / ((c1 - 0) * (c1 - c2) * (c1 - 1))
    l2 = (Θ - 0) * (Θ - c1) * (Θ - 1) / ((c2 - 0) * (c2 - c1) * (c2 - 1))
    l3 = (Θ - 0) * (Θ - c1) * (Θ - c2) / ((1 - 0) * (1 - c1) * (1 - c2))
    #l4 = 0 * (Θ - c1) * (Θ - c2) * (Θ - 1) / ((0 - c1) * (0 - c2) * (0 - 1))
    @.. y₀ + z1 * l1 + z2 * l2 + z3 * l3
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k, cache::Union{RadauIIA5ConstantCache, RadauIIA5Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; c1, c2) = cache.tab
    z1 = k[3]
    z2 = k[4]
    z3 = k[5]

    l1 = (Θ - 0) * (Θ - c2) * (Θ - 1) / ((c1 - 0) * (c1 - c2) * (c1 - 1))
    l2 = (Θ - 0) * (Θ - c1) * (Θ - 1) / ((c2 - 0) * (c2 - c1) * (c2 - 1))
    l3 = (Θ - 0) * (Θ - c1) * (Θ - c2) / ((1 - 0) * (1 - c1) * (1 - c2))
    #l4 = 0 * (Θ - c1) * (Θ - c2) * (Θ - 1) / ((0 - c1) * (0 - c2) * (0 - 1))
    @.. out = y₀ + z1 * l1 + z2 * l2 + z3 * l3
end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k, cache::Union{RadauIIA9ConstantCache, RadauIIA9Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; c1, c2, c3, c4) = cache.tab

    z1 = k[3]
    z2 = k[4]
    z3 = k[5]
    z4 = k[6]
    z5 = k[7]

    l1 = (Θ - 0) * (Θ - c2) * (Θ - c3) * (Θ - c4) * (Θ - 1) / ((c1 - 0) * (c1 - c2) * (c1 - c3) * (c1 - c4) * (c1 - 1))
    l2 = (Θ - 0) * (Θ - c1) * (Θ - c3) * (Θ - c4) * (Θ - 1) / ((c2 - 0) * (c2 - c1) * (c2 - c3) * (c2 - c4) * (c2 - 1))
    l3 = (Θ - 0) * (Θ - c1) * (Θ - c2) * (Θ - c4) * (Θ - 1) / ((c3 - 0) * (c3 - c1) * (c3 - c2) * (c3 - c4) * (c3 - 1))
    l4 = (Θ - 0) * (Θ - c1) * (Θ - c2) * (Θ - c3) * (Θ - 1) / ((c4 - 0) * (c4 - c1) * (c4 - c2) * (c4 - c3) * (c4 - 1))
    l5 = (Θ - 0) * (Θ - c1) * (Θ - c2) * (Θ - c3) * (Θ - c4) / ((1 - 0) * (1 - c1) * (1 - c2) * (1 - c3) * (1 - c4))
    #l6 = 0 * (Θ - c1) * (Θ - c2) * (Θ - c3) * (Θ - c4) * (Θ - 1) / ((0 - c1) * (0 - c2) * (0 - c3) * (0 - c4) * (0 - 1))
    @.. y₀ + z1 * l1 + z2 * l2 + z3 * l3 + z4 * l4 + z5 * l5

end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k, cache::Union{RadauIIA9ConstantCache, RadauIIA9Cache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; c1, c2, c3, c4) = cache.tab

    z1 = k[3]
    z2 = k[4]
    z3 = k[5]
    z4 = k[6]
    z5 = k[7]

    l1 = (Θ - 0) * (Θ - c2) * (Θ - c3) * (Θ - c4) * (Θ - 1) / ((c1 - 0) * (c1 - c2) * (c1 - c3) * (c1 - c4) * (c1 - 1))
    l2 = (Θ - 0) * (Θ - c1) * (Θ - c3) * (Θ - c4) * (Θ - 1) / ((c2 - 0) * (c2 - c1) * (c2 - c3) * (c2 - c4) * (c2 - 1))
    l3 = (Θ - 0) * (Θ - c1) * (Θ - c2) * (Θ - c4) * (Θ - 1) / ((c3 - 0) * (c3 - c1) * (c3 - c2) * (c3 - c4) * (c3 - 1))
    l4 = (Θ - 0) * (Θ - c1) * (Θ - c2) * (Θ - c3) * (Θ - 1) / ((c4 - 0) * (c4 - c1) * (c4 - c2) * (c4 - c3) * (c4 - 1))
    l5 = (Θ - 0) * (Θ - c1) * (Θ - c2) * (Θ - c3) * (Θ - c4) / ((1 - 0) * (1 - c1) * (1 - c2) * (1 - c3) * (1 - c4))

    @.. out = y₀ + z1 * l1 + z2 * l2 + z3 * l3 + z4 * l4 + z5 * l5

end

@muladd function _ode_interpolant(
        Θ, dt, y₀, y₁, k, cache::Union{AdaptiveRadauConstantCache, AdaptiveRadauCache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; num_stages, index) = cache
    (; c) = cache.tabs[index]

    for i in 1:num_stages
        tmp = k[i + 2]
        for j in 1:num_stages
            if j != i
                tmp *= (Θ - c[j]) / (c[i] - c[j])
            end
        end
        y₀ = @.. y₀ + tmp * Θ / c[i]
    end
    y₀
end

@muladd function _ode_interpolant!(
        out, Θ, dt, y₀, y₁, k, cache::Union{AdaptiveRadauConstantCache, AdaptiveRadauCache},
        idxs::Nothing, T::Type{Val{0}}, differential_vars
    )
    (; num_stages, index) = cache
    (; c) = cache.tabs[index]

    tmp = similar(out)
    out .= y₀
    for i in 1:num_stages
        tmp .= k[i + 2]
        for j in 1:num_stages
            if j != i
                tmp .*= (Θ - c[j]) / (c[i] - c[j])
            end
        end
        @.. out += tmp * Θ / c[i]
    end
    out
end

function _ode_addsteps!(integrator, cache::RadauIIA3ConstantCache)
    (; t, dt, uprev, u, f, p, k) = integrator
    (; T11, T12, T21, T22, TI11, TI12, TI21, TI22) = cache.tab
    (; c1, c2, α, β, e1, e2) = cache.tab
    (; κ, cont1, cont2) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations
    rtol = @. reltol^(3 / 4) / 10
    atol = @. rtol * (abstol / reltol)
    αdt, βdt = α / dt, β / dt
    J = calc_J(integrator, cache)

    c1m1 = c1 - 1
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        uzero = zero(eltype(u))
        z1 = @.. uzero
        z2 = @.. uzero
        w1 = @.. uzero
        w2 = @.. uzero
        integrator.k[3] = uzero
        integrator.k[4] = uzero
    else
        c2′ = dt / cache.dtprev
        c1′ = c1 * c2′
        z1 = @.. c1′ * (k[3] + (c1′ - c1m1) * k[4])
        z2 = @.. c2′ * (k[3] + (c2′ - c1m1) * k[4])
        w1 = @.. TI11 * z1 + TI12 * z2
        w2 = @.. TI21 * z1 + TI22 * z2
    end

    if u isa Number
        LU1 = -(αdt + βdt * im) * mass_matrix + J
    else
        LU1 = lu(-(αdt + βdt * im) * mass_matrix + J)
    end
    integrator.stats.nw += 1

    # Newton iteration
    local ff1, ff2
    # Initialize variables for JET
    ndw = one(eltype(u))
    ndwprev = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1
        # evaluate function
        ff1 = f(uprev + z1, p, t + c1 * dt)
        ff2 = f(uprev + z2, p, t + c2 * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)

        fw1 = @. TI11 * ff1 + TI12 * ff2
        fw2 = @. TI21 * ff1 + TI22 * ff2

        if mass_matrix isa UniformScaling
            Mw1 = @. mass_matrix.λ * w1
            Mw2 = @. mass_matrix.λ * w2
        else
            Mw1 = mass_matrix * w1
            Mw2 = mass_matrix * w2
        end

        rhs1 = @. fw1 - αdt * Mw1 + βdt * Mw2
        rhs2 = @. fw2 - βdt * Mw1 - αdt * Mw2
        dw12 = _reshape(LU1 \ _vec(@. rhs1 + rhs2 * im), axes(u))
        integrator.stats.nsolve += 1
        dw1 = real(dw12)
        dw2 = imag(dw12)

        # compute norm of residuals
        ndwprev = ndw
        atmp1 = calculate_residuals(dw1, uprev, u, atol, rtol, internalnorm, t)
        atmp2 = calculate_residuals(dw2, uprev, u, atol, rtol, internalnorm, t)
        ndw = internalnorm(atmp1, t) + internalnorm(atmp2, t)

        # check divergence (not in initial step)
        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        w1 = @. w1 - dw1
        w2 = @. w2 - dw2

        # transform `w` to `z`
        z1 = @. T11 * w1 + T12 * w2
        z2 = @. T21 * w1 + T22 * w2

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end

    if integrator.EEst <= oneunit(integrator.EEst)
        if alg.extrapolant != :constant
            integrator.k[3] = (z1 - z2) / c1m1
            integrator.k[4] = integrator.k[3] - (z1 / c1)
        end
    end

    u = @. uprev + z2

    integrator.fsallast = f(u, p, t + dt)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
    return
end

function _ode_addsteps!(integrator, cache::RadauIIA3Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p, fsallast, fsalfirst) = integrator
    (; T11, T12, T21, T22, TI11, TI12, TI21, TI22) = cache.tab
    (; c1, c2, α, β, e1, e2) = cache.tab
    (; κ) = cache
    (;
        z1, z2, w1, w2,
        dw12, cubuff,
        k, k2, fw1, fw2,
        J, W1,
        tmp, atmp, jac_config, rtol, atol, step_limiter!,
    ) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix
    # precalculations
    αdt, βdt = α / dt, β / dt
    new_jac = false
    if (new_W = do_newW(integrator, alg, new_jac, cache.W_γdt))
        @inbounds for II in CartesianIndices(J)
            W1[II] = -(αdt + βdt * im) * mass_matrix[Tuple(II)...] + J[II]
        end
        integrator.stats.nw += 1
    end

    c1m1 = c1 - 1
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        uzero = zero(eltype(u))
        @.. z1 = uzero
        @.. z2 = uzero
        @.. w1 = uzero
        @.. w2 = uzero
        @.. integrator.k[3] = uzero
        @.. integrator.k[4] = uzero
    else
        c2′ = dt / cache.dtprev
        c1′ = c1 * c2′
        @.. z1 = c1′ * (integrator.k[3] + (c1′ - c1m1) * integrator.k[4])
        @.. z2 = c2′ * (integrator.k[3] + (c2′ - c1m1) * integrator.k[4])
        @.. w1 = TI11 * z1 + TI12 * z2
        @.. w2 = TI21 * z1 + TI22 * z2
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    ndwprev = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1
        # evaluate function
        @. tmp = uprev + z1
        f(fsallast, tmp, p, t + c1 * dt)
        @. tmp = uprev + z2
        f(k2, tmp, p, t + c2 * dt)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)

        @. fw1 = TI11 * fsallast + TI12 * k2
        @. fw2 = TI21 * fsallast + TI22 * k2

        if mass_matrix === I
            Mw1 = w1
            Mw2 = w2
        elseif mass_matrix isa UniformScaling
            mul!(z1, mass_matrix.λ, w1)
            mul!(z2, mass_matrix.λ, w2)
            Mw1 = z1
            Mw2 = z2
        else
            mul!(z1, mass_matrix, w1)
            mul!(z2, mass_matrix, w2)
            Mw1 = z1
            Mw2 = z2
        end

        @. cubuff = complex(fw1 - αdt * Mw1 + βdt * Mw2, fw2 - βdt * Mw1 - αdt * Mw2)
        needfactor = iter == 1

        linsolve = cache.linsolve

        if needfactor
            linres = dolinsolve(
                integrator, linsolve; A = W1, b = _vec(cubuff),
                linu = _vec(dw12)
            )
        else
            linres = dolinsolve(
                integrator, linsolve; A = nothing, b = _vec(cubuff),
                linu = _vec(dw12)
            )
        end

        cache.linsolve = linres.cache

        integrator.stats.nsolve += 1
        dw1 = real(dw12)
        dw2 = imag(dw12)

        # compute norm of residuals
        ndwprev = ndw
        calculate_residuals!(atmp, dw1, uprev, u, atol, rtol, internalnorm, t)
        ndw1 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw2, uprev, u, atol, rtol, internalnorm, t)
        ndw2 = internalnorm(atmp, t)
        ndw = ndw1 + ndw2

        # check divergence (not in initial step)
        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 2) && (cache.status = Divergence)
            if diverge
                break
            end
            η = θ / (1 - θ)
        end

        @. w1 = w1 - dw1
        @. w2 = w2 - dw2

        # transform `w` to `z`
        @. z1 = T11 * w1 + T12 * w2
        @. z2 = T21 * w1 + T22 * w2

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end
    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        return
    end
    cache.ηold = η
    cache.iter = iter

    @. u = uprev + z2
    step_limiter!(u, integrator, p, t + dt)

    if integrator.EEst <= oneunit(integrator.EEst)
        cache.dtprev = dt
        if alg.extrapolant != :constant
            integrator.k[3] = (z1 - z2) / c1m1
            integrator.k[4] = integrator.k[3] - (z1 / c1)
        end
    end

    f(fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return
end

function _ode_addsteps!(
        integrator, cache::RadauIIA5ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p, k) = integrator
    (;
        T11, T12, T13, T21, T22, T23, T31, TI11, TI12, TI13,
        TI21, TI22, TI23, TI31, TI32, TI33,
    ) = cache.tab
    (; c1, c2, γ, α, β, e1, e2, e3) = cache.tab
    (; κ, cont1, cont2, cont3) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations
    rtol = @.. reltol^(2 / 3) / 10
    atol = @.. rtol * (abstol / reltol)
    c1m1 = c1 - 1
    c2m1 = c2 - 1
    c1mc2 = c1 - c2
    γdt, αdt, βdt = γ / dt, α / dt, β / dt
    J = calc_J(integrator, cache)
    if u isa Number
        LU1 = -γdt * mass_matrix + J
        LU2 = -(αdt + βdt * im) * mass_matrix + J
    else
        LU1 = lu(-γdt * mass_matrix + J)
        LU2 = lu(-(αdt + βdt * im) * mass_matrix + J)
    end
    integrator.stats.nw += 1

    # TODO better initial guess
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        uzero = map(zero, u)
        z1 = @.. uzero
        z2 = @.. uzero
        z3 = @.. uzero
        w1 = @.. uzero
        w2 = @.. uzero
        w3 = @.. uzero
        integrator.k[3] = uzero
        integrator.k[4] = uzero
        integrator.k[5] = uzero
    else
        c3′ = dt / cache.dtprev
        c1′ = c1 * c3′
        c2′ = c2 * c3′
        z1 = @.. c1′ * (k[3] + (c1′ - c2m1) * (k[4] + (c1′ - c1m1) * k[5]))
        z2 = @.. c2′ * (k[3] + (c2′ - c2m1) * (k[4] + (c2′ - c1m1) * k[5]))
        z3 = @.. c3′ * (k[3] + (c3′ - c2m1) * (k[4] + (c3′ - c1m1) * k[5]))
        w1 = @.. TI11 * z1 + TI12 * z2 + TI13 * z3
        w2 = @.. TI21 * z1 + TI22 * z2 + TI23 * z3
        w3 = @.. TI31 * z1 + TI32 * z2 + TI33 * z3
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1

        # evaluate function
        ff1 = f(uprev + z1, p, t + c1 * dt)
        ff2 = f(uprev + z2, p, t + c2 * dt)
        ff3 = f(uprev + z3, p, t + dt) # c3 = 1
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)

        fw1 = @.. TI11 * ff1 + TI12 * ff2 + TI13 * ff3
        fw2 = @.. TI21 * ff1 + TI22 * ff2 + TI23 * ff3
        fw3 = @.. TI31 * ff1 + TI32 * ff2 + TI33 * ff3

        if mass_matrix isa UniformScaling # `UniformScaling` doesn't play nicely with broadcast
            Mw1 = @.. mass_matrix.λ * w1
            Mw2 = @.. mass_matrix.λ * w2
            Mw3 = @.. mass_matrix.λ * w3
        else
            Mw1 = mass_matrix * w1
            Mw2 = mass_matrix * w2
            Mw3 = mass_matrix * w3
        end

        rhs1 = @.. fw1 - γdt * Mw1
        rhs2 = @.. fw2 - αdt * Mw2 + βdt * Mw3
        rhs3 = @.. fw3 - βdt * Mw2 - αdt * Mw3
        dw1 = _reshape(LU1 \ _vec(rhs1), axes(u))
        dw23 = _reshape(LU2 \ _vec(@.. rhs2 + rhs3 * im), axes(u))
        integrator.stats.nsolve += 2
        dw2 = real(dw23)
        dw3 = imag(dw23)

        # compute norm of residuals
        ndwprev = ndw
        atmp1 = calculate_residuals(dw1, uprev, u, atol, rtol, internalnorm, t)
        atmp2 = calculate_residuals(dw2, uprev, u, atol, rtol, internalnorm, t)
        atmp3 = calculate_residuals(dw3, uprev, u, atol, rtol, internalnorm, t)
        ndw = internalnorm(atmp1, t) + internalnorm(atmp2, t) + internalnorm(atmp3, t)
        # check divergence (not in initial step)
        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        w1 = @.. w1 - dw1
        w2 = @.. w2 - dw2
        w3 = @.. w3 - dw3

        # transform `w` to `z`
        z1 = @.. T11 * w1 + T12 * w2 + T13 * w3
        z2 = @.. T21 * w1 + T22 * w2 + T23 * w3
        z3 = @.. T31 * w1 + w2           # T32 = 1, T33 = 0

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end
    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        error("This shouldn't happen. Report a bug please.")
    end
    cache.ηold = η
    cache.iter = iter

    u = @.. uprev + z3

    if integrator.EEst <= oneunit(integrator.EEst)
        if alg.extrapolant != :constant
            integrator.k[3] = (z2 - z3) / c2m1
            tmp = @.. (z1 - z2) / c1mc2
            integrator.k[4] = (tmp - integrator.k[3]) / c1m1
            integrator.k[5] = integrator.k[4] - (tmp - z1 / c1) / c2
        end
    end

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return
end

function _ode_addsteps!(integrator, cache::RadauIIA5Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p, fsallast, fsalfirst, k) = integrator
    (;
        T11, T12, T13, T21, T22, T23, T31, TI11, TI12, TI13,
        TI21, TI22, TI23, TI31, TI32, TI33,
    ) = cache.tab
    (; c1, c2, γ, α, β, e1, e2, e3) = cache.tab
    (; κ) = cache
    (;
        z1, z2, z3, w1, w2, w3,
        dw1, ubuff, dw23, cubuff,
        k, k2, k3, fw1, fw2, fw3,
        J, W1, W2,
        tmp, atmp, jac_config, linsolve1, linsolve2, rtol, atol, step_limiter!,
    ) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations
    c1m1 = c1 - 1
    c2m1 = c2 - 1
    c1mc2 = c1 - c2
    γdt, αdt, βdt = γ / dt, α / dt, β / dt
    new_jac = false
    if (new_W = do_newW(integrator, alg, new_jac, cache.W_γdt))
        @inbounds for II in CartesianIndices(J)
            W1[II] = -γdt * mass_matrix[Tuple(II)...] + J[II]
            W2[II] = -(αdt + βdt * im) * mass_matrix[Tuple(II)...] + J[II]
        end
        integrator.stats.nw += 1
    end

    # TODO better initial guess
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        uzero = zero(eltype(u))
        @.. z1 = uzero
        @.. z2 = uzero
        @.. z3 = uzero
        @.. w1 = uzero
        @.. w2 = uzero
        @.. w3 = uzero
        @.. integrator.k[3] = uzero
        @.. integrator.k[4] = uzero
        @.. integrator.k[5] = uzero
    else
        c3′ = dt / cache.dtprev
        c1′ = c1 * c3′
        c2′ = c2 * c3′
        @.. z1 = c1′ * (
            integrator.k[3] +
                (c1′ - c2m1) * (integrator.k[4] + (c1′ - c1m1) * integrator.k[5])
        )
        @.. z1 = c2′ * (
            integrator.k[3] +
                (c2′ - c2m1) * (integrator.k[4] + (c2′ - c1m1) * integrator.k[5])
        )
        @.. z1 = c3′ * (
            integrator.k[3] +
                (c3′ - c2m1) * (integrator.k[4] + (c3′ - c1m1) * integrator.k[5])
        )
        @.. w1 = TI11 * z1 + TI12 * z2 + TI13 * z3
        @.. w2 = TI21 * z1 + TI22 * z2 + TI23 * z3
        @.. w3 = TI31 * z1 + TI32 * z2 + TI33 * z3
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1

        # evaluate function
        @.. tmp = uprev + z1
        f(fsallast, tmp, p, t + c1 * dt)
        @.. tmp = uprev + z2
        f(k2, tmp, p, t + c2 * dt)
        @.. tmp = uprev + z3
        f(k3, tmp, p, t + dt) # c3 = 1
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)

        @.. fw1 = TI11 * fsallast + TI12 * k2 + TI13 * k3
        @.. fw2 = TI21 * fsallast + TI22 * k2 + TI23 * k3
        @.. fw3 = TI31 * fsallast + TI32 * k2 + TI33 * k3

        if mass_matrix === I
            Mw1 = w1
            Mw2 = w2
            Mw3 = w3
        elseif mass_matrix isa UniformScaling
            mul!(z1, mass_matrix.λ, w1)
            mul!(z2, mass_matrix.λ, w2)
            mul!(z3, mass_matrix.λ, w3)
            Mw1 = z1
            Mw2 = z2
            Mw3 = z3
        else
            mul!(z1, mass_matrix, w1)
            mul!(z2, mass_matrix, w2)
            mul!(z3, mass_matrix, w3)
            Mw1 = z1
            Mw2 = z2
            Mw3 = z3
        end

        @.. ubuff = fw1 - γdt * Mw1
        needfactor = iter == 1 && new_W

        linsolve1 = cache.linsolve1

        if needfactor
            linres1 = dolinsolve(
                integrator, linsolve1; A = W1, b = _vec(ubuff),
                linu = _vec(dw1)
            )
        else
            linres1 = dolinsolve(
                integrator, linsolve1; A = nothing, b = _vec(ubuff),
                linu = _vec(dw1)
            )
        end

        cache.linsolve1 = linres1.cache

        @.. cubuff = complex(
            fw2 - αdt * Mw2 + βdt * Mw3,
            fw3 - βdt * Mw2 - αdt * Mw3
        )

        linsolve2 = cache.linsolve2

        if needfactor
            linres2 = dolinsolve(
                integrator, linsolve2; A = W2, b = _vec(cubuff),
                linu = _vec(dw23)
            )
        else
            linres2 = dolinsolve(
                integrator, linsolve2; A = nothing, b = _vec(cubuff),
                linu = _vec(dw23)
            )
        end

        cache.linsolve2 = linres2.cache

        integrator.stats.nsolve += 2
        dw2 = z2
        dw3 = z3
        @.. dw2 = real(dw23)
        @.. dw3 = imag(dw23)

        # compute norm of residuals
        ndwprev = ndw
        calculate_residuals!(atmp, dw1, uprev, u, atol, rtol, internalnorm, t)
        ndw1 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw2, uprev, u, atol, rtol, internalnorm, t)
        ndw2 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw3, uprev, u, atol, rtol, internalnorm, t)
        ndw3 = internalnorm(atmp, t)
        ndw = ndw1 + ndw2 + ndw3

        # check divergence (not in initial step)
        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        @.. w1 = w1 - dw1
        @.. w2 = w2 - dw2
        @.. w3 = w3 - dw3

        # transform `w` to `z`
        @.. z1 = T11 * w1 + T12 * w2 + T13 * w3
        @.. z2 = T21 * w1 + T22 * w2 + T23 * w3
        @.. z3 = T31 * w1 + w2           # T32 = 1, T33 = 0

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end
    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        return
    end
    cache.ηold = η
    cache.iter = iter

    @.. u = uprev + z3
    step_limiter!(u, integrator, p, t + dt)

    if integrator.EEst <= oneunit(integrator.EEst)
        cache.dtprev = dt
        if alg.extrapolant != :constant
            integrator.k[3] = (z2 - z3) / c2m1
            @.. tmp = (z1 - z2) / c1mc2
            integrator.k[4] = (tmp - integrator.k[3]) / c1m1
            integrator.k[5] = integrator.k[4] - (tmp - z1 / c1) / c2
        end
    end

    f(fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return
end

function _ode_addsteps!(
        integrator, cache::RadauIIA9ConstantCache,
        repeat_step = false
    )
    (; t, dt, uprev, u, f, p, k) = integrator
    (;
        T11, T12, T13, T14, T15, T21, T22, T23, T24, T25, T31, T32,
        T33, T34, T35, T41, T42, T43, T44, T45, T51,
    ) = cache.tab #= T52 = 1, T53 = 0, T54 = 1, T55 = 0=#
    (;
        TI11,
        TI12, TI13, TI14, TI15, TI21, TI22, TI23, TI24, TI25, TI31, TI32, TI33, TI34,
        TI35, TI41, TI42, TI43, TI44, TI45, TI51, TI52, TI53, TI54, TI55,
    ) = cache.tab
    (; c1, c2, c3, c4, γ, α1, β1, α2, β2, e1, e2, e3, e4, e5) = cache.tab
    (; κ) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations rtol pow is (num stages + 1)/(2*num stages)
    rtol = @.. reltol^(3 / 5) / 10
    atol = @.. rtol * (abstol / reltol)
    c1m1 = c1 - 1
    c2m1 = c2 - 1
    c3m1 = c3 - 1
    c4m1 = c4 - 1
    c1mc2 = c1 - c2
    c1mc3 = c1 - c3
    c1mc4 = c1 - c4
    c2mc3 = c2 - c3
    c2mc4 = c2 - c4
    c3mc4 = c3 - c4

    γdt, α1dt, β1dt, α2dt, β2dt = γ / dt, α1 / dt, β1 / dt, α2 / dt, β2 / dt
    J = calc_J(integrator, cache)
    if u isa Number
        LU1 = -γdt * mass_matrix + J
        LU2 = -(α1dt + β1dt * im) * mass_matrix + J
        LU3 = -(α2dt + β2dt * im) * mass_matrix + J
    else
        LU1 = lu(-γdt * mass_matrix + J)
        LU2 = lu(-(α1dt + β1dt * im) * mass_matrix + J)
        LU3 = lu(-(α2dt + β2dt * im) * mass_matrix + J)
    end
    integrator.stats.nw += 1

    # TODO better initial guess
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        z1 = map(zero, u)
        z2 = map(zero, u)
        z3 = map(zero, u)
        z4 = map(zero, u)
        z5 = map(zero, u)
        w1 = map(zero, u)
        w2 = map(zero, u)
        w3 = map(zero, u)
        w4 = map(zero, u)
        w5 = map(zero, u)
        integrator.k[3] = map(zero, u)
        integrator.k[4] = map(zero, u)
        integrator.k[5] = map(zero, u)
        integrator.k[6] = map(zero, u)
        integrator.k[7] = map(zero, u)
    else
        c5′ = dt / cache.dtprev
        c1′ = c1 * c5′
        c2′ = c2 * c5′
        c3′ = c3 * c5′
        c4′ = c4 * c5′
        z1 = @.. c1′ * (
            k[3] +
                (c1′ - c4m1) * (
                k[4] +
                    (c1′ - c3m1) * (
                    k[5] +
                        (c1′ - c2m1) * (k[6] + (c1′ - c1m1) * k[7])
                )
            )
        )
        z2 = @.. c2′ * (
            k[3] +
                (c2′ - c4m1) * (
                k[4] +
                    (c2′ - c3m1) * (
                    k[5] +
                        (c2′ - c2m1) * (k[6] + (c2′ - c1m1) * k[7])
                )
            )
        )
        z3 = @.. c3′ * (
            k[3] +
                (c3′ - c4m1) * (
                k[4] +
                    (c3′ - c3m1) * (
                    k[5] +
                        (c3′ - c2m1) * (k[6] + (c3′ - c1m1) * k[7])
                )
            )
        )
        z4 = @.. c4′ * (
            k[3] +
                (c4′ - c4m1) * (
                k[4] +
                    (c4′ - c3m1) * (
                    k[5] +
                        (c4′ - c2m1) * (k[6] + (c4′ - c1m1) * k[7])
                )
            )
        )
        z5 = @.. c5′ * (
            k[3] +
                (c5′ - c4m1) * (
                k[4] +
                    (c5′ - c3m1) * (k[5] + (c5′ - c2m1) * (k[6] + (c5′ - c1m1) * k[7]))
            )
        )
        w1 = @.. TI11 * z1 + TI12 * z2 + TI13 * z3 + TI14 * z4 + TI15 * z5
        w2 = @.. TI21 * z1 + TI22 * z2 + TI23 * z3 + TI24 * z4 + TI25 * z5
        w3 = @.. TI31 * z1 + TI32 * z2 + TI33 * z3 + TI34 * z4 + TI35 * z5
        w4 = @.. TI41 * z1 + TI42 * z2 + TI43 * z3 + TI44 * z4 + TI45 * z5
        w5 = @.. TI51 * z1 + TI52 * z2 + TI53 * z3 + TI54 * z4 + TI55 * z5
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1

        # evaluate function
        ff1 = f(uprev + z1, p, t + c1 * dt)
        ff2 = f(uprev + z2, p, t + c2 * dt)
        ff3 = f(uprev + z3, p, t + c3 * dt)
        ff4 = f(uprev + z4, p, t + c4 * dt)
        ff5 = f(uprev + z5, p, t + dt) # c5 = 1
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)

        fw1 = @.. TI11 * ff1 + TI12 * ff2 + TI13 * ff3 + TI14 * ff4 + TI15 * ff5
        fw2 = @.. TI21 * ff1 + TI22 * ff2 + TI23 * ff3 + TI24 * ff4 + TI25 * ff5
        fw3 = @.. TI31 * ff1 + TI32 * ff2 + TI33 * ff3 + TI34 * ff4 + TI35 * ff5
        fw4 = @.. TI41 * ff1 + TI42 * ff2 + TI43 * ff3 + TI44 * ff4 + TI45 * ff5
        fw5 = @.. TI51 * ff1 + TI52 * ff2 + TI53 * ff3 + TI54 * ff4 + TI55 * ff5

        if mass_matrix isa UniformScaling # `UniformScaling` doesn't play nicely with broadcast
            Mw1 = @.. mass_matrix.λ * w1
            Mw2 = @.. mass_matrix.λ * w2
            Mw3 = @.. mass_matrix.λ * w3
            Mw4 = @.. mass_matrix.λ * w4
            Mw5 = @.. mass_matrix.λ * w5
        else
            Mw1 = mass_matrix * w1
            Mw2 = mass_matrix * w2
            Mw3 = mass_matrix * w3
            Mw4 = mass_matrix * w4
            Mw5 = mass_matrix * w5
        end

        rhs1 = @.. fw1 - γdt * Mw1
        rhs2 = @.. fw2 - α1dt * Mw2 + β1dt * Mw3
        rhs3 = @.. fw3 - β1dt * Mw2 - α1dt * Mw3
        rhs4 = @.. fw4 - α2dt * Mw4 + β2dt * Mw5
        rhs5 = @.. fw5 - β2dt * Mw4 - α2dt * Mw5
        dw1 = _reshape(LU1 \ _vec(rhs1), axes(u))
        dw23 = _reshape(LU2 \ _vec(@.. rhs2 + rhs3 * im), axes(u))
        dw45 = _reshape(LU3 \ _vec(@.. rhs4 + rhs5 * im), axes(u))
        integrator.stats.nsolve += 3
        dw2 = real(dw23)
        dw3 = imag(dw23)
        dw4 = real(dw45)
        dw5 = imag(dw45)

        # compute norm of residuals
        ndwprev = ndw
        atmp1 = calculate_residuals(dw1, uprev, u, atol, rtol, internalnorm, t)
        atmp2 = calculate_residuals(dw2, uprev, u, atol, rtol, internalnorm, t)
        atmp3 = calculate_residuals(dw3, uprev, u, atol, rtol, internalnorm, t)
        atmp4 = calculate_residuals(dw4, uprev, u, atol, rtol, internalnorm, t)
        atmp5 = calculate_residuals(dw5, uprev, u, atol, rtol, internalnorm, t)
        ndw = internalnorm(atmp1, t) + internalnorm(atmp2, t) + internalnorm(atmp3, t) +
            internalnorm(atmp4, t) + internalnorm(atmp5, t)

        # check divergence (not in initial step)

        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        w1 = @.. w1 - dw1
        w2 = @.. w2 - dw2
        w3 = @.. w3 - dw3
        w4 = @.. w4 - dw4
        w5 = @.. w5 - dw5

        # transform `w` to `z`
        z1 = @.. T11 * w1 + T12 * w2 + T13 * w3 + T14 * w4 + T15 * w5
        z2 = @.. T21 * w1 + T22 * w2 + T23 * w3 + T24 * w4 + T25 * w5
        z3 = @.. T31 * w1 + T32 * w2 + T33 * w3 + T34 * w4 + T35 * w5
        z4 = @.. T41 * w1 + T42 * w2 + T43 * w3 + T44 * w4 + T45 * w5
        z5 = @.. T51 * w1 + w2 + w4 #= T52=1, T53=0, T54=1, T55=0 =#

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end

    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        return
    end
    #cache.ηold = η
    #cache.iter = iter

    u = @.. uprev + z5

    if integrator.EEst <= oneunit(integrator.EEst)
        #cache.dtprev = dt
        if alg.extrapolant != :constant
            integrator.k[3] = (z4 - z5) / c4m1 # first derivative on [c4, 1]
            tmp1 = @.. (z3 - z4) / c3mc4 # first derivative on [c3, c4]
            integrator.k[4] = (tmp1 - integrator.k[3]) / c3m1 # second derivative on [c3, 1]
            tmp2 = @.. (z2 - z3) / c2mc3 # first derivative on [c2, c3]
            tmp3 = @.. (tmp2 - tmp1) / c2mc4 # second derivative on [c2, c4]
            integrator.k[5] = (tmp3 - integrator.k[4]) / c2m1 # third derivative on [c2, 1]
            tmp4 = @.. (z1 - z2) / c1mc2 # first derivative on [c1, c2]
            tmp5 = @.. (tmp4 - tmp2) / c1mc3 # second derivative on [c1, c3]
            tmp6 = @.. (tmp5 - tmp3) / c1mc4 # third derivative on [c1, c4]
            integrator.k[6] = (tmp6 - integrator.k[5]) / c1m1 #fourth derivative on [c1, 1]
            tmp7 = @.. z1 / c1 #first derivative on [0, c1]
            tmp8 = @.. (tmp4 - tmp7) / c2 #second derivative on [0, c2]
            tmp9 = @.. (tmp5 - tmp8) / c3 #third derivative on [0, c3]
            tmp10 = @.. (tmp6 - tmp9) / c4 #fourth derivative on [0,c4]
            integrator.k[7] = integrator.k[6] - tmp10 #fifth derivative on [0,1]
        end
    end

    integrator.fsallast = f(u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
    return
end

function _ode_addsteps!(integrator, cache::RadauIIA9Cache, repeat_step = false)
    (; t, dt, uprev, u, f, p, fsallast, fslafirst, k) = integrator
    (;
        T11, T12, T13, T14, T15, T21, T22, T23, T24, T25, T31, T32,
        T33, T34, T35, T41, T42, T43, T44, T45, T51,
    ) = cache.tab #= T52 = 1, T53 = 0, T54 = 1, T55 = 0=#
    (;
        TI11,
        TI12, TI13, TI14, TI15, TI21, TI22, TI23, TI24, TI25, TI31, TI32, TI33, TI34,
        TI35, TI41, TI42, TI43, TI44, TI45, TI51, TI52, TI53, TI54, TI55,
    ) = cache.tab
    (; c1, c2, c3, c4, γ, α1, β1, α2, β2, e1, e2, e3, e4, e5) = cache.tab
    (; κ) = cache
    (; z1, z2, z3, z4, z5, w1, w2, w3, w4, w5) = cache
    (; dw1, ubuff, dw23, dw45, cubuff1, cubuff2) = cache
    (; k, k2, k3, k4, k5, fw1, fw2, fw3, fw4, fw5) = cache
    (; J, W1, W2, W3) = cache
    (;
        tmp, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7, tmp8, tmp9, tmp10, atmp, jac_config,
        linsolve1, linsolve2, linsolve3, rtol, atol, step_limiter!,
    ) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations
    c1m1 = c1 - 1
    c2m1 = c2 - 1
    c3m1 = c3 - 1
    c4m1 = c4 - 1
    c1mc2 = c1 - c2
    c1mc3 = c1 - c3
    c1mc4 = c1 - c4
    c2mc3 = c2 - c3
    c2mc4 = c2 - c4
    c3mc4 = c3 - c4

    γdt, α1dt, β1dt, α2dt, β2dt = γ / dt, α1 / dt, β1 / dt, α2 / dt, β2 / dt
    new_jac = false
    if (new_W = do_newW(integrator, alg, new_jac, cache.W_γdt))
        @inbounds for II in CartesianIndices(J)
            W1[II] = -γdt * mass_matrix[Tuple(II)...] + J[II]
            W2[II] = -(α1dt + β1dt * im) * mass_matrix[Tuple(II)...] + J[II]
            W3[II] = -(α2dt + β2dt * im) * mass_matrix[Tuple(II)...] + J[II]
        end
        integrator.stats.nw += 1
    end

    # TODO better initial guess
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        uzero = zero(eltype(u))
        @.. z1 = uzero
        @.. z2 = uzero
        @.. z3 = uzero
        @.. z4 = uzero
        @.. z5 = uzero
        @.. w1 = uzero
        @.. w2 = uzero
        @.. w3 = uzero
        @.. w4 = uzero
        @.. w5 = uzero
        @.. integrator.k[3] = uzero
        @.. integrator.k[4] = uzero
        @.. integrator.k[5] = uzero
        @.. integrator.k[6] = uzero
        @.. integrator.k[7] = uzero
    else
        c5′ = dt / cache.dtprev
        c1′ = c1 * c5′
        c2′ = c2 * c5′
        c3′ = c3 * c5′
        c4′ = c4 * c5′
        @.. z1 = c1′ * (
            integrator.k[3] +
                (c1′ - c4m1) * (
                integrator.k[4] +
                    (c1′ - c3m1) * (
                    integrator.k[5] +
                        (c1′ - c2m1) * (integrator.k[6] + (c1′ - c1m1) * integrator.k[7])
                )
            )
        )
        @.. z2 = c2′ * (
            integrator.k[3] +
                (c2′ - c4m1) * (
                integrator.k[4] +
                    (c2′ - c3m1) * (
                    integrator.k[5] +
                        (c2′ - c2m1) * (integrator.k[6] + (c2′ - c1m1) * integrator.k[7])
                )
            )
        )
        @.. z3 = c3′ * (
            integrator.k[3] +
                (c3′ - c4m1) * (
                integrator.k[4] +
                    (c3′ - c3m1) * (
                    integrator.k[5] +
                        (c3′ - c2m1) * (integrator.k[6] + (c3′ - c1m1) * integrator.k[7])
                )
            )
        )
        @.. z4 = c4′ * (
            integrator.k[3] +
                (c4′ - c4m1) * (
                integrator.k[4] +
                    (c4′ - c3m1) * (
                    integrator.k[5] +
                        (c4′ - c2m1) * (integrator.k[6] + (c4′ - c1m1) * integrator.k[7])
                )
            )
        )
        @.. z5 = c5′ * (
            integrator.k[3] +
                (c5′ - c4m1) * (
                integrator.k[4] +
                    (c5′ - c3m1) * (
                    integrator.k[5] +
                        (c5′ - c2m1) * (integrator.k[6] + (c5′ - c1m1) * integrator.k[7])
                )
            )
        )
        @.. w1 = TI11 * z1 + TI12 * z2 + TI13 * z3 + TI14 * z4 + TI15 * z5
        @.. w2 = TI21 * z1 + TI22 * z2 + TI23 * z3 + TI24 * z4 + TI25 * z5
        @.. w3 = TI31 * z1 + TI32 * z2 + TI33 * z3 + TI34 * z4 + TI35 * z5
        @.. w4 = TI41 * z1 + TI42 * z2 + TI43 * z3 + TI44 * z4 + TI45 * z5
        @.. w5 = TI51 * z1 + TI52 * z2 + TI53 * z3 + TI54 * z4 + TI55 * z5
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1

        # evaluate function
        @.. tmp = uprev + z1
        f(fsallast, tmp, p, t + c1 * dt)
        @.. tmp = uprev + z2
        f(k2, tmp, p, t + c2 * dt)
        @.. tmp = uprev + z3
        f(k3, tmp, p, t + c3 * dt)
        @.. tmp = uprev + z4
        f(k4, tmp, p, t + c4 * dt)
        @.. tmp = uprev + z5
        f(k5, tmp, p, t + dt) # c5 = 1
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)

        @.. fw1 = TI11 * fsallast + TI12 * k2 + TI13 * k3 + TI14 * k4 +
            TI15 * k5
        @.. fw2 = TI21 * fsallast + TI22 * k2 + TI23 * k3 + TI24 * k4 +
            TI25 * k5
        @.. fw3 = TI31 * fsallast + TI32 * k2 + TI33 * k3 + TI34 * k4 +
            TI35 * k5
        @.. fw4 = TI41 * fsallast + TI42 * k2 + TI43 * k3 + TI44 * k4 +
            TI45 * k5
        @.. fw5 = TI51 * fsallast + TI52 * k2 + TI53 * k3 + TI54 * k4 +
            TI55 * k5

        if mass_matrix === I
            Mw1 = w1
            Mw2 = w2
            Mw3 = w3
            Mw4 = w4
            Mw5 = w5
        elseif mass_matrix isa UniformScaling
            mul!(z1, mass_matrix.λ, w1)
            mul!(z2, mass_matrix.λ, w2)
            mul!(z3, mass_matrix.λ, w3)
            mul!(z4, mass_matrix.λ, w4)
            mul!(z5, mass_matrix.λ, w5)
            Mw1 = z1
            Mw2 = z2
            Mw3 = z3
            Mw4 = z4
            Mw5 = z5
        else
            mul!(z1, mass_matrix, w1)
            mul!(z2, mass_matrix, w2)
            mul!(z3, mass_matrix, w3)
            mul!(z4, mass_matrix, w4)
            mul!(z5, mass_matrix, w5)
            Mw1 = z1
            Mw2 = z2
            Mw3 = z3
            Mw4 = z4
            Mw5 = z5
        end

        @.. ubuff = fw1 - γdt * Mw1
        needfactor = iter == 1 && new_W

        linsolve1 = cache.linsolve1

        if needfactor
            linres1 = dolinsolve(
                integrator, linsolve1; A = W1, b = _vec(ubuff), linu = _vec(dw1)
            )
        else
            linres1 = dolinsolve(
                integrator, linsolve1; A = nothing, b = _vec(ubuff), linu = _vec(dw1)
            )
        end

        cache.linsolve1 = linres1.cache

        @.. cubuff1 = complex(
            fw2 - α1dt * Mw2 + β1dt * Mw3, fw3 - β1dt * Mw2 - α1dt * Mw3
        )

        linsolve2 = cache.linsolve2

        if needfactor
            linres2 = dolinsolve(
                integrator, linsolve2; A = W2, b = _vec(cubuff1), linu = _vec(dw23)
            )
        else
            linres2 = dolinsolve(
                integrator, linsolve2; A = nothing, b = _vec(cubuff1), linu = _vec(dw23)
            )
        end

        cache.linsolve2 = linres2.cache

        @.. cubuff2 = complex(
            fw4 - α2dt * Mw4 + β2dt * Mw5, fw5 - β2dt * Mw4 - α2dt * Mw5
        )

        linsolve3 = cache.linsolve3

        if needfactor
            linres3 = dolinsolve(
                integrator, linsolve3; A = W3, b = _vec(cubuff2), linu = _vec(dw45)
            )
        else
            linres3 = dolinsolve(
                integrator, linsolve3; A = nothing, b = _vec(cubuff2), linu = _vec(dw45)
            )
        end

        cache.linsolve3 = linres3.cache
        integrator.stats.nsolve += 3
        dw2 = z2
        dw3 = z3
        @.. dw2 = real(dw23)
        @.. dw3 = imag(dw23)
        dw4 = z4
        dw5 = z5
        @.. dw4 = real(dw45)
        @.. dw5 = imag(dw45)

        # compute norm of residuals
        ndwprev = ndw
        calculate_residuals!(atmp, dw1, uprev, u, atol, rtol, internalnorm, t)
        ndw1 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw2, uprev, u, atol, rtol, internalnorm, t)
        ndw2 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw3, uprev, u, atol, rtol, internalnorm, t)
        ndw3 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw4, uprev, u, atol, rtol, internalnorm, t)
        ndw4 = internalnorm(atmp, t)
        calculate_residuals!(atmp, dw5, uprev, u, atol, rtol, internalnorm, t)
        ndw5 = internalnorm(atmp, t)
        ndw = ndw1 + ndw2 + ndw3 + ndw4 + ndw5

        # check divergence (not in initial step)

        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        @.. w1 = w1 - dw1
        @.. w2 = w2 - dw2
        @.. w3 = w3 - dw3
        @.. w4 = w4 - dw4
        @.. w5 = w5 - dw5

        # transform `w` to `z`
        @.. z1 = T11 * w1 + T12 * w2 + T13 * w3 + T14 * w4 + T15 * w5
        @.. z2 = T21 * w1 + T22 * w2 + T23 * w3 + T24 * w4 + T25 * w5
        @.. z3 = T31 * w1 + T32 * w2 + T33 * w3 + T34 * w4 + T35 * w5
        @.. z4 = T41 * w1 + T42 * w2 + T43 * w3 + T44 * w4 + T45 * w5
        @.. z5 = T51 * w1 + w2 + w4 #= T52=1, T53=0, T54=1, T55=0 =#

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end
    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        return
    end

    cache.ηold = η
    cache.iter = iter

    @.. u = uprev + z5

    step_limiter!(u, integrator, p, t + dt)

    if alg.extrapolant != :constant
        integrator.k[3] = (z4 - z5) / c4m1 # first derivative on [c4, 1]
        @.. tmp = (z3 - z4) / c3mc4 # first derivative on [c3, c4]
        integrator.k[4] = (tmp - integrator.k[3]) / c3m1 # second derivative on [c3, 1]
        @.. tmp2 = (z2 - z3) / c2mc3 # first derivative on [c2, c3]
        @.. tmp3 = (tmp2 - tmp) / c2mc4 # second derivative on [c2, c4]
        integrator.k[5] = (tmp3 - integrator.k[4]) / c2m1 # third derivative on [c2, 1]
        @.. tmp4 = (z1 - z2) / c1mc2 # first derivative on [c1, c2]
        @.. tmp5 = (tmp4 - tmp2) / c1mc3 # second derivative on [c1, c3]
        @.. tmp6 = (tmp5 - tmp3) / c1mc4 # third derivative on [c1, c4]
        integrator.k[6] = (tmp6 - integrator.k[5]) / c1m1 #fourth derivative on [c1, 1]
        @.. tmp7 = z1 / c1 #first derivative on [0, c1]
        @.. tmp8 = (tmp4 - tmp7) / c2 #second derivative on [0, c2]
        @.. tmp9 = (tmp5 - tmp8) / c3 #third derivative on [0, c3]
        @.. tmp10 = (tmp6 - tmp9) / c4 #fourth derivative on [0,c4]
        integrator.k[7] = integrator.k[6] - tmp10 #fifth derivative on [0,1]
    end

    f(fsallast, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    return
end

function _ode_addstep!(integrator, cache::AdaptiveRadauConstantCache, repeat_step = false)
    (; t, dt, uprev, u, f, p, k) = integrator
    (; tabs, num_stages, index) = cache
    tab = tabs[index]
    (; T, TI, γ, α, β, c, e) = tab
    (; κ) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations rtol pow is (num stages + 1)/(2*num stages)
    rtol = @.. reltol^((num_stages + 1) / (num_stages * 2)) / 10
    atol = @.. rtol * (abstol / reltol)

    γdt, αdt, βdt = γ / dt, α ./ dt, β ./ dt
    J = calc_J(integrator, cache)

    if u isa Number
        LU1 = -γdt * mass_matrix + J
        tmp = -(αdt[1] + βdt[1] * im) * mass_matrix + J
    else
        LU1 = lu(-γdt * mass_matrix + J)
        tmp = lu(-(αdt[1] + βdt[1] * im) * mass_matrix + J)
    end
    LU2 = Vector{typeof(tmp)}(undef, (num_stages - 1) ÷ 2)
    LU2[1] = tmp
    if u isa Number
        for i in 2:((num_stages - 1) ÷ 2)
            LU2[i] = -(αdt[i] + βdt[i] * im) * mass_matrix + J
        end
    else
        for i in 2:((num_stages - 1) ÷ 2)
            LU2[i] = lu(-(αdt[i] + βdt[i] * im) * mass_matrix + J)
        end
    end

    integrator.stats.nw += 1
    z = Vector{typeof(u)}(undef, num_stages)
    w = Vector{typeof(u)}(undef, num_stages)
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        for i in 1:num_stages
            z[i] = @.. map(zero, u)
            w[i] = @.. map(zero, u)
            integrator.k[i + 2] = map(zero, u)
        end
    else
        c_prime = Vector{typeof(dt)}(undef, num_stages) #time stepping
        c_prime[num_stages] = dt / cache.dtprev
        for i in 1:(num_stages - 1)
            c_prime[i] = c[i] * c_prime[num_stages]
        end
        for i in 1:num_stages # collocation polynomial
            z[i] = @.. k[num_stages + 1] + k[num_stages + 2] * (c_prime[i] - c[1] + 1)
            j = num_stages - 2
            while j > 0
                z[i] = @.. k[j + 2] + z[i] * (c_prime[i] - c[num_stages - j] + 1)
                j = j - 1
            end
            z[i] = @.. z[i] * c_prime[i]
        end
        #w = TI*z
        for i in 1:num_stages
            w[i] = @.. zero(u)
            for j in 1:num_stages
                w[i] = @.. w[i] + TI[i, j] * z[j]
            end
        end
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1

        # evaluate function
        #ff = Vector{typeof(u)}(undef, num_stages)
        for i in 1:num_stages
            z[i] = f(uprev + z[i], p, t + c[i] * dt)
        end
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, num_stages)

        #fw = TI * ff
        fw = Vector{typeof(u)}(undef, num_stages)
        for i in 1:num_stages
            fw[i] = @.. zero(u)
            for j in 1:num_stages
                fw[i] = @.. fw[i] + TI[i, j] * z[j]
            end
        end

        #Mw = Vector{typeof(u)}(undef, num_stages)
        if mass_matrix isa UniformScaling # `UniformScaling` doesn't play nicely with broadcast
            for i in 1:num_stages
                z[i] = @.. mass_matrix.λ * w[i] #scaling by eigenvalue
            end
        else
            z = mass_matrix * w #standard multiplication
        end

        rhs = Vector{typeof(u)}(undef, num_stages)
        rhs[1] = @.. fw[1] - γdt * z[1]
        i = 2
        while i <= num_stages #block by block multiplication
            rhs[i] = @.. fw[i] - αdt[i ÷ 2] * z[i] + βdt[i ÷ 2] * z[i + 1]
            rhs[i + 1] = @.. fw[i + 1] - βdt[i ÷ 2] * z[i] - αdt[i ÷ 2] * z[i + 1]
            i += 2
        end

        #dw = Vector{typeof(u)}(undef, num_stages)
        z[1] = _reshape(LU1 \ _vec(rhs[1]), axes(u))
        for i in 2:((num_stages + 1) ÷ 2)
            tmp = _reshape(LU2[i - 1] \ _vec(@.. rhs[2 * i - 2] + rhs[2 * i - 1] * im), axes(u))
            z[2 * i - 2] = @.. real(tmp)
            z[2 * i - 1] = @.. imag(tmp)
        end
        integrator.stats.nsolve += (num_stages + 1) ÷ 2

        # compute norm of residuals
        ndwprev = ndw
        ndw = 0.0
        for i in 1:num_stages
            ndw += internalnorm(
                calculate_residuals(
                    z[i], uprev, u, atol, rtol, internalnorm, t
                ), t
            )
        end

        # check divergence (not in initial step)

        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        for i in 1:num_stages
            w[i] = @.. w[i] - z[i]
        end

        # transform `w` to `z`
        #z = T * w
        for i in 1:(num_stages - 1)
            z[i] = @.. zero(u)
            for j in 1:num_stages
                z[i] = @.. z[i] + T[i, j] * w[j]
            end
        end
        z[num_stages] = @.. T[num_stages, 1] * w[1]
        i = 2
        while i < num_stages
            z[num_stages] = @.. z[num_stages] + w[i]
            i += 2
        end

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end

    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        return
    end
    cache.ηold = η
    cache.iter = iter

    u = @.. uprev + z[num_stages]

    if integrator.EEst <= oneunit(integrator.EEst)
        cache.dtprev = dt
        if alg.extrapolant != :constant
            derivatives = Matrix{typeof(u)}(undef, num_stages, num_stages)
            derivatives[1, 1] = @.. z[1] / c[1]
            for j in 2:num_stages
                derivatives[1, j] = @.. (z[j - 1] - z[j]) / (c[j - 1] - c[j]) #first derivatives
            end
            for i in 2:num_stages
                derivatives[i, i] = @.. (
                    derivatives[i - 1, i] -
                        derivatives[i - 1, i - 1]
                ) / c[i]
                for j in (i + 1):num_stages
                    derivatives[i, j] = @.. (
                        derivatives[i - 1, j - 1] -
                            derivatives[i - 1, j]
                    ) / (c[j - i] - c[j]) #all others
                end
            end
            for i in 1:num_stages
                integrator.k[i + 2] = @.. derivatives[i, num_stages]
            end
        end
    end

    integrator.fsallast = f(u, p, t + dt)
    integrator.stats.nf += 1
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    integrator.u = u
    return
end

function _ode_addsteps!(integrator, cache::AdaptiveRadauCache, repeat_step = false)
    (; t, dt, uprev, u, f, p, fsallast, fsalfirst, k) = integrator
    (; num_stages, tabs, index) = cache
    tab = tabs[index]
    (; T, TI, γ, α, β, c, e) = tab
    (; κ, derivatives, z, w, c_prime, αdt, βdt) = cache
    (; dw1, ubuff, dw2, cubuff, dw) = cache
    (; ks, k, fw, J, W1, W2) = cache
    (; tmp, atmp, jac_config, linsolve1, linsolve2, rtol, atol, step_limiter!) = cache
    (; internalnorm, abstol, reltol, adaptive) = integrator.opts
    alg = unwrap_alg(integrator, true)
    (; maxiters) = alg
    mass_matrix = integrator.f.mass_matrix

    # precalculations
    γdt = γ / dt
    for i in 1:((num_stages - 1) ÷ 2)
        αdt[i] = α[i] / dt
        βdt[i] = β[i] / dt
    end

    if integrator.opts.adaptive
        (; abstol, reltol) = integrator.opts
        if reltol isa Number
            cache.rtol = reltol^((num_stages + 1) / (2 * num_stages)) / 10
            cache.atol = cache.rtol * (abstol / reltol)
        else
            @.. cache.rtol = reltol^((num_stages + 1) / (2 * num_stages)) / 10
            @.. cache.atol = cache.rtol * (abstol / reltol)
        end
    end

    #no new J
    new_jac = false
    if (new_W = do_newW(integrator, alg, new_jac, cache.W_γdt))
        @inbounds for II in CartesianIndices(J)
            W1[II] = -γdt * mass_matrix[Tuple(II)...] + J[II]
        end
        if !isthreaded(alg.threading)
            @inbounds for II in CartesianIndices(J)
                for i in 1:((num_stages - 1) ÷ 2)
                    W2[i][II] = -(αdt[i] + βdt[i] * im) * mass_matrix[Tuple(II)...] + J[II]
                end
            end
        else
            let W1 = W1, W2 = W2, γdt = γdt, αdt = αdt, βdt = βdt,
                    mass_matrix = mass_matrix, num_stages = num_stages, J = J

                @inbounds @threaded alg.threading for i in 1:((num_stages - 1) ÷ 2)
                    for II in CartesianIndices(J)
                        W2[i][II] = -(αdt[i] + βdt[i] * im) * mass_matrix[Tuple(II)...] +
                            J[II]
                    end
                end
            end
        end
        integrator.stats.nw += 1
    end

    # TODO better initial guess
    if integrator.iter == 1 || integrator.u_modified || alg.extrapolant == :constant
        cache.dtprev = one(cache.dtprev)
        for i in 1:num_stages
            @.. z[i] = map(zero, u)
            @.. w[i] = map(zero, u)
            integrator.k[i + 2] = map(zero, u)
        end
    else
        c_prime[num_stages] = dt
        for i in 1:(num_stages - 1)
            c_prime[i] = c[i] * c_prime[num_stages]
        end
        for i in 1:num_stages # collocation polynomial
            @.. z[i] = k[num_stages + 2] * (c_prime[i] - c[1] + 1) + k[num_stages + 1]
            j = num_stages - 2
            while j > 0
                @.. z[i] *= (c_prime[i] - c[num_stages - j] + 1)
                @.. z[i] += k[j + 2]
                j = j - 1
            end
            @.. z[i] *= c_prime[i]
        end
        #mul!(w, TI, z)
        for i in 1:num_stages
            @.. w[i] = zero(u)
            for j in 1:num_stages
                @.. w[i] += TI[i, j] * z[j]
            end
        end
    end

    # Newton iteration
    # Initialize variables for JET
    ndw = one(eltype(u))
    η = max(cache.ηold, eps(eltype(integrator.opts.reltol)))^(0.8)
    fail_convergence = true
    iter = 0
    while iter < maxiters
        iter += 1
        integrator.stats.nnonliniter += 1

        # evaluate function
        ks[1] = fsallast
        for i in 1:num_stages
            @.. tmp = uprev + z[i]
            f(ks[i], tmp, p, t + c[i] * dt)
        end
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, num_stages)

        #mul!(fw, TI, ks)
        for i in 1:num_stages
            @.. fw[i] = zero(u)
            for j in 1:num_stages
                @.. fw[i] += TI[i, j] * ks[j]
            end
        end

        if mass_matrix === I
            Mw = w
        elseif mass_matrix isa UniformScaling
            for i in 1:num_stages
                mul!(z[i], mass_matrix.λ, w[i])
            end
            Mw = z
        else
            for i in 1:num_stages
                mul!(z[i], mass_matrix, w[i])
            end
            Mw = z
        end

        @.. ubuff = fw[1] - γdt * Mw[1]
        needfactor = iter == 1 && new_W

        if needfactor
            cache.linsolve1 = dolinsolve(
                integrator, linsolve1; A = W1, b = _vec(ubuff), linu = _vec(dw1)
            ).cache
        else
            cache.linsolve1 = dolinsolve(
                integrator, linsolve1; A = nothing, b = _vec(ubuff), linu = _vec(dw1)
            ).cache
        end

        if !isthreaded(alg.threading)
            for i in 1:((num_stages - 1) ÷ 2)
                @.. cubuff[i] = complex(
                    fw[2 * i] - αdt[i] * Mw[2 * i] + βdt[i] * Mw[2 * i + 1],
                    fw[2 * i + 1] - βdt[i] * Mw[2 * i] - αdt[i] * Mw[2 * i + 1]
                )
                if needfactor
                    cache.linsolve2[i] = dolinsolve(
                        integrator, linsolve2[i]; A = W2[i],
                        b = _vec(cubuff[i]), linu = _vec(dw2[i])
                    ).cache
                else
                    cache.linsolve2[i] = dolinsolve(
                        integrator, linsolve2[i]; A = nothing,
                        b = _vec(cubuff[i]), linu = _vec(dw2[i])
                    ).cache
                end
            end
        else
            let integrator = integrator, linsolve2 = linsolve2, fw = fw, αdt = αdt,
                    βdt = βdt, Mw = Mw, W1 = W1, W2 = W2, cubuff = cubuff, dw2 = dw2,
                    needfactor = needfactor

                @threaded alg.threading for i in 1:((num_stages - 1) ÷ 2)
                    @.. cubuff[i] = complex(
                        fw[2 * i] - αdt[i] * Mw[2 * i] + βdt[i] * Mw[2 * i + 1],
                        fw[2 * i + 1] - βdt[i] * Mw[2 * i] - αdt[i] * Mw[2 * i + 1]
                    )
                    if needfactor
                        cache.linsolve2[i] = dolinsolve(
                            integrator, linsolve2[i]; A = W2[i],
                            b = _vec(cubuff[i]), linu = _vec(dw2[i])
                        ).cache
                    else
                        cache.linsolve2[i] = dolinsolve(
                            integrator, linsolve2[i]; A = nothing,
                            b = _vec(cubuff[i]), linu = _vec(dw2[i])
                        ).cache
                    end
                end
            end
        end

        integrator.stats.nsolve += (num_stages + 1) / 2

        for i in 1:((num_stages - 1) ÷ 2)
            @.. dw[2 * i - 1] = real(dw2[i])
            @.. dw[2 * i] = imag(dw2[i])
        end

        # compute norm of residuals
        ndwprev = ndw
        calculate_residuals!(atmp, dw1, uprev, u, atol, rtol, internalnorm, t)
        ndw = internalnorm(atmp, t)
        for i in 2:num_stages
            calculate_residuals!(atmp, dw[i - 1], uprev, u, atol, rtol, internalnorm, t)
            ndw += internalnorm(atmp, t)
        end

        # check divergence (not in initial step)

        if iter > 1
            θ = ndw / ndwprev
            (diverge = θ > 1) && (cache.status = Divergence)
            (veryslowconvergence = ndw * θ^(maxiters - iter) > κ * (1 - θ)) &&
                (cache.status = VerySlowConvergence)
            if diverge || veryslowconvergence
                break
            end
            η = θ / (1 - θ)
        end

        @.. w[1] = w[1] - dw1
        for i in 2:num_stages
            @.. w[i] = w[i] - dw[i - 1]
        end

        # transform `w` to `z`
        #mul!(z, T, w)
        for i in 1:(num_stages - 1)
            @.. z[i] = zero(u)
            for j in 1:num_stages
                @.. z[i] += T[i, j] * w[j]
            end
        end
        @.. z[num_stages] = T[num_stages, 1] * w[1]
        i = 2
        while i < num_stages
            @.. z[num_stages] += w[i]
            i += 2
        end

        # check stopping criterion
        if η * ndw < κ && (iter > 1 || iszero(ndw) || !iszero(integrator.success_iter))
            # Newton method converges
            cache.status = η < alg.fast_convergence_cutoff ? FastConvergence :
                Convergence
            fail_convergence = false
            break
        end
    end
    if fail_convergence
        integrator.force_stepfail = true
        integrator.stats.nnonlinconvfail += 1
        return
    end

    cache.ηold = η
    cache.iter = iter

    @.. u = uprev + z[num_stages]

    step_limiter!(u, integrator, p, t + dt)

    if integrator.EEst <= oneunit(integrator.EEst)
        cache.dtprev = dt
        if alg.extrapolant != :constant
            @.. derivatives[1, 1] = z[1] / c[1]
            for j in 2:num_stages
                @.. derivatives[1, j] = (z[j - 1] - z[j]) / (c[j - 1] - c[j]) #first derivatives
            end
            for i in 2:num_stages
                @.. derivatives[i, i] = (
                    derivatives[i - 1, i] -
                        derivatives[i - 1, i - 1]
                ) / c[i]
                for j in (i + 1):num_stages
                    @.. derivatives[i, j] = (
                        derivatives[i - 1, j - 1] -
                            derivatives[i - 1, j]
                    ) / (c[j - i] - c[j]) #all others
                end
            end
            for i in 1:num_stages
                integrator.k[i + 2] = derivatives[i, num_stages]
            end
        end
    end

    f(fsallast, u, p, t + dt)
    integrator.stats.nf += 1
    return
end

@inline function SciMLBase.get_tmp_cache(
        integrator, alg::Union{RadauIIA3, RadauIIA5, RadauIIA9, AdaptiveRadau},
        cache::OrdinaryDiffEqMutableCache
    )
    return (cache.tmp, cache.atmp)
end

using OrdinaryDiffEqFIRK, DiffEqDevTools, Test, LinearAlgebra
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear, prob_ode_vanderpol

testTol = 0.5

for prob in [prob_ode_linear, prob_ode_2Dlinear]
    sim21 = test_convergence(1 .// 2 .^ (6:-1:3), prob, RadauIIA5(), dense_errors = true)
    @test sim21.𝒪est[:final] ≈ 5 atol = testTol
    @test sim21.𝒪est[:L2] ≈ 4 atol = testTol
end

sim21 = test_convergence(1 ./ 2 .^ (2.5:-1:0.5), prob_ode_linear, RadauIIA9(), dense_errors = true)
@test sim21.𝒪est[:final] ≈ 8 atol = testTol
@test sim21.𝒪est[:L2] ≈ 6 atol = testTol

sim21 = test_convergence(1 ./ 2 .^ (2.5:-1:0.5), prob_ode_2Dlinear, RadauIIA9(), dense_errors = true)
@test sim21.𝒪est[:final] ≈ 8 atol = testTol
@test sim21.𝒪est[:L2] ≈ 6 atol = testTol

using GenericSchur

prob_ode_linear_big = remake(
    prob_ode_linear, u0 = big.(prob_ode_linear.u0), tspan = big.(prob_ode_linear.tspan)
)
prob_ode_2Dlinear_big = remake(
    prob_ode_2Dlinear, u0 = big.(prob_ode_2Dlinear.u0),
    tspan = big.(prob_ode_2Dlinear.tspan)
)

#non-threaded tests
for i in [5, 9, 13, 17, 21, 25], prob in [prob_ode_linear_big, prob_ode_2Dlinear_big]
    dts = 1 ./ 2 .^ (4.25:-1:0.25)
    local sim21 = test_convergence(dts, prob, AdaptiveRadau(min_order = i, max_order = i), dense_errors = true)
    @test sim21.𝒪est[:final] ≈ i atol = testTol
    @test sim21.𝒪est[:L2] ≈ ((i + 3) ÷ 2) atol = testTol
end

#threaded tests
using OrdinaryDiffEqCore
for i in [5, 9, 13, 17, 21, 25], prob in [prob_ode_linear_big, prob_ode_2Dlinear_big]

    dts = 1 ./ 2 .^ (4.25:-1:0.25)
    local sim21 = test_convergence(
        dts,
        prob,
        AdaptiveRadau(min_order = i, max_order = i, threading = OrdinaryDiffEqCore.PolyesterThreads()), dense_errors = true
    )
    @test sim21.𝒪est[:final] ≈ i atol = testTol
    @test sim21.𝒪est[:L2] ≈ ((i + 3) ÷ 2) atol = testTol
end

# Create Van der Pol stiff problem using the same ordering as ODEProblemLibrary
# New implementation: u[1] = x, u[2] = y, p[1] = μ
# Initial conditions: [x, y] = [sqrt(3), 0] (matching original [sys.x => sqrt(3), sys.y => 0])
function vanderpol_firk(du, u, p, t)
    x, y = u[1], u[2]
    μ = p[1]
    du[1] = y                           # dx/dt = y
    return du[2] = μ * ((1 - x^2) * y - x)     # dy/dt = μ * ((1 - x^2) * y - x)
end

function vanderpol_firk(u, p, t)
    x, y = u[1], u[2]
    μ = p[1]
    return [
        y,                           # dx/dt = y
        μ * ((1 - x^2) * y - x),
    ]     # dy/dt = μ * ((1 - x^2) * y - x)
end

# test adaptivity
for iip in (true, false)
    vanstiff = ODEProblem{iip}(vanderpol_firk, [sqrt(3), 0.0], (0.0, 1.0), [1.0e6])
    sol = solve(vanstiff, RadauIIA5())
    if iip
        @test sol.stats.naccept + sol.stats.nreject > sol.stats.njacs # J reuse
        @test sol.stats.njacs < sol.stats.nw # W reuse
    end
    @test length(sol) < 150
    @test SciMLBase.successful_retcode(sol)
    sol_temp = solve(remake(vanstiff, p = [1.0e7]), RadauIIA5())
    @test length(sol_temp) < 150
    @test SciMLBase.successful_retcode(sol_temp)
    sol_temp2 = solve(remake(vanstiff, p = [1.0e7]), reltol = [1.0e-6, 1.0e-4], RadauIIA5())
    @test length(sol_temp2) < 180
    @test SciMLBase.successful_retcode(sol_temp2)
    sol_temp3 = solve(
        remake(vanstiff, p = [1.0e7]), RadauIIA5(), reltol = 1.0e-9,
        abstol = 1.0e-9
    )
    @test length(sol_temp3) < 970
    @test SciMLBase.successful_retcode(sol_temp3)
    sol_temp4 = solve(remake(vanstiff, p = [1.0e9]), RadauIIA5())
    @test length(sol_temp4) < 170
    @test SciMLBase.successful_retcode(sol_temp4)
    sol_temp5 = solve(remake(vanstiff, p = [1.0e10]), RadauIIA5())
    @test length(sol_temp5) < 190
    @test SciMLBase.successful_retcode(sol_temp5)
end

##Tests for RadauIIA3
for prob in [prob_ode_linear, prob_ode_2Dlinear]
    dts = 1 ./ 2 .^ (8:-1:1)
    sim = test_convergence(dts, prob, RadauIIA3(), dense_errors = true)
    @test sim.𝒪est[:final] ≈ 3 atol = 0.25
    @test sim.𝒪est[:L2] ≈ 3 atol = 0.25
end

# test adaptivity
for iip in (true, false)
    vanstiff = ODEProblem{iip}(vanderpol_firk, [sqrt(3), 0], (0.0, 1.0), [1.0e6])
    sol = solve(vanstiff, RadauIIA3())
    if iip
        @test sol.stats.naccept + sol.stats.nreject > sol.stats.njacs # J reuse
        @test sol.stats.njacs < sol.stats.nw # W reuse
    end
    @test length(sol) < 5000 # the error estimate is not very good
    @test SciMLBase.successful_retcode(sol)
end

module OrdinaryDiffEqFIRK

import OrdinaryDiffEqCore: alg_order, calculate_residuals!,
    initialize!, perform_step!, unwrap_alg,
    calculate_residuals,
    OrdinaryDiffEqAlgorithm, OrdinaryDiffEqNewtonAdaptiveAlgorithm,
    OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
    OrdinaryDiffEqAdaptiveAlgorithm, CompiledFloats, uses_uprev,
    alg_cache, _vec, _reshape, @cache, @threaded, isthreaded,
    PolyesterThreads,
    isfsal, full_cache, constvalue, _unwrap_val,
    differentiation_rk_docstring, trivial_limiter!,
    _ode_interpolant!, _ode_addsteps!, AbstractController,
    qmax_default, alg_adaptive_order, DEFAULT_PRECS,
    stepsize_controller!, step_accept_controller!,
    step_reject_controller!,
    PredictiveController, alg_can_repeat_jac, NewtonAlgorithm,
    fac_default_gamma,
    get_current_adaptive_order, get_fsalfirstlast,
    isfirk, generic_solver_docstring, _bool_to_ADType,
    _process_AD_choice, LinearAliasSpecifier
using MuladdMacro, DiffEqBase, RecursiveArrayTools, Polyester
isfirk, generic_solver_docstring
using SciMLOperators: AbstractSciMLOperator
using LinearAlgebra: I, UniformScaling, mul!, lu
import LinearSolve
import FastBroadcast: @..
import OrdinaryDiffEqCore
import OrdinaryDiffEqCore: _ode_interpolant, _ode_interpolant!, has_stiff_interpolation
import FastPower: fastpower
using OrdinaryDiffEqDifferentiation: UJacobianWrapper, build_J_W, build_jac_config,
    UDerivativeWrapper, calc_J!, dolinsolve, calc_J,
    islinearfunction
using OrdinaryDiffEqNonlinearSolve: du_alias_or_new, Convergence, FastConvergence, NLStatus,
    VerySlowConvergence,
    Divergence, get_new_W_γdt_cutoff
import ADTypes: AutoForwardDiff, AbstractADType

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.4"
    @eval begin
        import OrdinaryDiffEqCore: PredictiveControllerCache, NewPredictiveController
    end
end

@static if Base.pkgversion(OrdinaryDiffEqCore) >= v"3.10"
    @eval begin
        import OrdinaryDiffEqCore: get_current_qmax
    end
else
    @eval begin
        # Fallback for older OrdinaryDiffEqCore: no first-step qmax behavior
        @inline get_current_qmax(integrator, qmax) = qmax
    end
end

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("controllers.jl")
include("firk_caches.jl")
include("firk_tableaus.jl")
include("firk_perform_step.jl")
include("firk_interpolants.jl")
include("firk_addsteps.jl")
include("integrator_interface.jl")

export RadauIIA3, RadauIIA5, RadauIIA9, AdaptiveRadau

end
